Before running the spotl.install script, remember to modify the Makefile in /src
to have the correct flags for your compilers (Fortran and C).

Documentation is in the /doc directory; see the README there for more
information.

This directory contains the documentation, in two forms:

	/troff	This contains the supplementary documentation (spotl.doc)
		and the man pages (xxx.1). Note that the .PZ command is
		nonstandard troff (it is used to set the point size).

	/postscript	This contains compressed PostScript of the man pages
			and supplementary documents, the figures for the
			latter, and a draft of a short paper summarizing the
			loading program. The best order to read these in is
			probably the paper, then the man pages for the program
			nloadf, and then the first part of the supplementary
			documentation, along with the man pages for the other
			programs.

			The PostScript should be processable on most laser
			printers; just zcat the file to the printer.

      subroutine tdfrph(idood,freq,phase)
      double precision freq,phase,fr,ph,tm,rft
      dimension fr(6,2),ph(6,2),idood(6),rft(2)
c
c   Given the Doodson number of a tidal constituent (in idood), returns
c  the frequency and phase.  Phase is returned in degrees and frequency
c  in cycles/day.
c
c   Note that phases must be decreased by 90 degrees if the sum of the order
c  and the species number is odd (as for the 2nd degree diurnals, and 3rd
c  degree low-frequency and semidiurnals).
c   These phases may need further adjustment to allow for the spherical
c  harmonic normalization used; e.g. for that used for the potential by
c  Cartwright and Tayler, 180 degrees must be added for (species,order)
c  = (1,2), (1,3), or (3,3).
c
c  Common block date stores time information. phase at given time is computed
c  from frequency, and phase at reference times (1924, day 142.5, or 1960,
c  day 143.5). Times before 1900 will cause a stop.
c  Frequencies and phases are from Cartwright and Tayler, Geophys. J.,
c  vol. 23, p 56 (1971)
c
c       calls only system routines
c
      common/date/iyr,iday,ihr,imin,isec
      data rft/8906.5,22056.5/,
     2 fr/1.d0,3.66011025d-2,2.7379092d-3,3.094554d-4,1.470941d-4,
     3    1.3708d-7,
     4    1.d0,3.66011023d-2,2.7379092d-3,3.094548d-4,1.47094d-4,
     5    1.3708d-7/,
     6 ph/1.8d2,272.60245d0,58.85684d0,246.60455d0,212.47704d0,
     7    281.64011d0,
     8    1.8d2, 22.22101d0,60.11923d0,271.56503d0,188.82048d0,
     9    282.25919d0/
c  find the time in days from 1 jan 1900 (if before 1900 stop)
      if(iyr.lt.1900) stop
      tm = iday - 1 + 365.d0*(iyr-1900) + (iyr-1901)/4
c  see if we want to use the first or second set of numbers
      ind = tm/15482. + 1.
      if(ind.gt.2) ind = 2
      fday = ihr/24.d0 + imin/1440.d0 + isec/86400.d0
      tm = tm + fday - rft(ind)
      freq = idood(1)*(fr(1,ind) - fr(2,ind) + fr(3,ind))
      phase = idood(1)*(ph(1,ind) - ph(2,ind) + ph(3,ind))
      do 7 i = 2,6
      freq = freq + fr(i,ind)*idood(i)
 7    phase = phase + ph(i,ind)*idood(i)
      phase = phase + 360.d0*freq*tm
c adjust phases to fall in the positive range 0 to 360
      phase = dmod(phase,360.d0)
      if(phase.lt.0.d0) phase = phase + 360.d0
      return
      end

c   program mapmak
c  reads from the random-access land-sea data file and outputs:
c   1. a printer-plot of the land and sea within 300 km of a specified
c      point
c   2. a printer-plot of a 2 by 2 degree area, 48 by 48 points, to
c      show the local structure of the land-sea file.
c
c $$$$calls lndsea, mrsden, invspt
c
      character*1 lin,opt
      character*50 dumm
      dimension lin(120)
      common/stloc/ct,st,rlam,ht
      data ht/0./,degk/111./,dr/.017453293/,
     1 del/0./,minaz/60/,delmax/12./
      if(iargc().lt.3) then
	 write(6,100)
 100     format('usage: mapcheck r lat long dist',/,
     1          ' or    mapcheck h lat long ',/,
     2    ' or    mapcheck o lat long')
	 stop
      endif
      call getarg(1,opt)
      call getarg(2,dumm)
      read(dumm,102) rlat
 102  format(f10.0)
      call getarg(3,dumm)
      read(dumm,102) rlam
      if(opt.eq.'r') then
         call getarg(4,dumm)
	 read(dumm,102) stp
      endif
      cl = dr*(90.-rlat)
      ct = cos(cl)
      st = sin(cl)
      if(opt.eq.'r') then
         stp = stp/33.
c 43 lines of 67 characters gives a square map
         fac = 33./21.
         do 9 jj=1,43
         y = fac*stp*(22-jj)
         maxp = 0
         do 7 kk=1,67
         lin(kk) = '-'
         x = stp*(kk-34)
         del = sqrt(x**2+y**2)/degk
         asz = 0.
         if(del.ne.0) asz = atan2(y,x)/dr
         asz = 90-asz
         call invspt(asz,del,b,rlong)
         rlat = 90 - b
         call lndsea(rlat,rlong,lnd)
         if(lnd.eq.2) lin(kk)=' '
         if(del.eq.0) lin(kk)='X'
         if(lin(kk).ne.' ') maxp = kk
 7       continue
         if(maxp.eq.0) write(6,110)
 110     format(1x)
         if(maxp.ne.0) write(6,112) (lin(i),i=1,maxp)
 112     format(1x,67a1)
 9       continue
      elseif(opt.eq.'h') then
         lat=nint(rlat)
         long=nint(rlam)
         off = 1./128.
         dt = 1./64.
         do 15 i=1,64
         rlat = lat + off + (64-i)*dt
         do 13 j=1,64
         lin(j) = '-'
         rlong = long + off + (j-1.)*dt
         if(i.eq.1.and.j.eq.1) write(6,122) rlat,rlong
 122     format(' corner coordinates: ',2f10.3)
         call lndsea(rlat,rlong,lnd)
 13      if(lnd.eq.2) lin(j) = '  '
         write(6,112) (lin(k),k=1,64)
         if(i.eq.64) write(6,122) rlat,rlong
 15      continue
      elseif(opt.eq.'o') then
 23      del = del + .1
         naz = 360.*sin(dr*del)
         naz = max0(naz,minaz)
         azstp = 360./naz
         alp = azstp/2.
         do 25 jj=1,naz
         call invspt(alp,del,b,rlong)
         call lndsea(90.-b,rlong,lnd)
         if(lnd.eq.1) go to 25
c  have an ocean cell - give distance and azimuth
         write(6,132) del,alp
 132     format(' Nearest water at distance ',f6.1,' deg, azimuth ',
     1           f6.1)
         stop
 25      alp = alp + azstp
         if(del.le.delmax) go to 23
         write(6,134) delmax
 134     format(' found no water within ',f6.1,' degrees')
      endif
      stop
      end
      subroutine invspt(alp,del,b,rlong)
c  solves the inverse spherical triangle problem - given a station whose
c  colatitude is t, and east longitude rlam (in degrees), returns the
c  colatitude b and east longitude rlong of the place which is at a distance
c  of delta degrees and at an azimuth of alp (clockwise from north).
c  the common block stloc holds the cosine and sine of the station colatitude,
c  and its east longitude.
      common/stloc/ct,st,rlam,ht
      data dtr/.01745329251/
      ca = cos(alp*dtr)
      sa = sin(alp*dtr)
      cd = cos(del*dtr)
      sd = sin(del*dtr)
      cb = cd*ct + sd*st*ca
      sb = sqrt(1.-cb*cb)
      b = acos(cb)/dtr
      if(sb.le.1.e-3) go to 1
      sg = sd*sa/sb
      cg = (st*cd-sd*ct*ca)/sb
      g = atan2(sg,cg)/dtr
      rlong = rlam + g
      return
c  special case - the point is at the poles
 1    rlong = 0
      return
      end

      subroutine lndsea(rlat,rlong,lnd)
c   for given north latitude and east longitude (in degrees) returns
c  the flag lnd = 1 if land, 2 if water (cf paul revere)
c    ***calls ibit
c
      double precision clat,clong,rlong2
      integer*2 index
      integer*4 map,mapful
      dimension index(259200),map(32),mapful(513120)
      data nlat/360/,nlong/720/,nfine/32/
      data ifrst/0/
      if(ifrst.eq.0) then
	 ifrst=1
         llu = 2
         open(unit=llu,file='lndsea.ind',status='old',access=
     $       'sequential',form="unformatted")
         read(llu) index
         close(llu)
	 nbl=1
         open(unit=llu,file='lndsea.bit',status='old',access=
     $       'sequential',form="unformatted")
 3       read(llu,end=7) map
	 do 5 i=1,32
 5       mapful(32*(nbl-1)+i) = map(i)
	 nbl=nbl+1
	 go to 3
 7       continue
	 close(llu)
      endif
c special branches for the polar regions, to avoid possible indexing trouble
      if(rlat.ge.85.) then
	 lnd=2
	 return
      endif
      if(rlat.le.-87.) then
	 lnd=1
	 return
      endif
      rlong2 = rlong
      if(rlong.lt.0) rlong2 = rlong + 360.
      if(rlong.gt.360) rlong2 = rlong - 360.
      clat = 90-rlat
      ilat = int(2*clat) + 1
      ilong = int(2*rlong2) + 1
      ind = 720*(ilat-1) + ilong
      if(index(ind).lt.0) then
	 lnd=-index(ind)
	 return
      endif
c are in a cell that is mixed land and sea: need to read the bit
c compute the lat and long of the SW corner
      clat = 90 - 0.5*ilat
      clong = 0.5*(ilong-1)
      idlat=min(int(64*(rlat-clat)) + 1,32)
      idlong=min(int(64*(rlong2-clong)) + 1,32)
c idlat and idlong are the indices to the bit-mapped version (32x32 bits)
c of the cell; the min function is to take care of the case when rlat
c or rlong are exactly 0.5 degrees from clat and clong.
c Now convert these to word and bit
      nwd = idlong + 32*(index(ind)-1)
      nbit = idlat
      iv = ibit(mapful(nwd),nbit)
      if(iv.eq.1) lnd = 1
      if(iv.eq.0) lnd = 2
      return
      end
      function ibit(id,n)
c
c  function to return the n-th bit (counting to the right) of a long
c  integer id
c
c    ***calls system routine and - this performs a bitwise and on
c       its two arguments
c
      save ibp,ifl
      integer*4 id,ibp(32),it
      data ifl/0/
      if(ifl.eq.1) go to 3
c  on first call, set up an array of integers, each with exactly one bit
c  set at successively lower values. ibp(1) should have only its highest
c  bit set; that this is true should be verified for each machine
      ifl = 1
      ibp(32) = 1
      do 1 i=2,32
 1    ibp(33-i) = 2*ibp(34-i)
 3    it = ispand(id,ibp(n))
      ibit = 0
      if(it.ne.0) ibit = 1
      return
      end

      subroutine plstart
c
c    Reads in, if requested, information about
c  polygonal areas (up to 10) within which the point either must or
c  must not fall.
c
      logical*1 ispoly,use
      character*1 iuse,alpoly
      character*80 polyf,dumm,polnam
c  common block holds polygon file information
      common/polinf/np,npoly(10),xpoly(100,10),ypoly(100,10),
     1            polyf,use(10),ispoly
      common/polynm/polnam,alpoly
      np=0
      llu = 4
      open(llu,file=polyf,status='old')
c first read name for whole file, and number of polygons; for each one,
c then read name (not used), number of points, + for point must be in,
c - for may not be, and then the points (long and lat) themselves.
c   The polygon coordinates may not cross a 360-degree discontinuity
c and must be in the range -180 to 180 or 0-360 (E +)
      read(llu,102) polnam
 102  format(a)
      read(llu,*) np
      do 9 i=1,np
      read(llu,102) dumm
      read(llu,*) npoly(i)
      read(llu,104) iuse
 104  format(a1)
      if(iuse.eq.'+') use(i) = .true.
      if(iuse.eq.'-') use(i) = .false.
c global override from variable alpoly, read from command line
      if(alpoly.eq.'+') use(i) = .true.
      if(alpoly.eq.'-') use(i) = .false.
      do 7 j=1,npoly(i)
      read(llu,*) xpoly(j,i),ypoly(j,i)
 7    continue
 9    continue
      close(llu)
      return
      end
      subroutine chkgon(rlong,rlat,iok)
c
c  returns iok=0 if
c     1. there is any polygon (of all those read in) in which the
c        coordinate should not fall, and it does
c             or
c     2. the coordinate should fall in at least one polygon
c        (of those read in) and it does not
c
c    otherwise returns iok=1
c
c    $$$$calls inpoly
c
      logical*1 ispoly,use
      character*80 polyf
      dimension xu(100),yu(100)
c  common block holds polygon file information
      common/polinf/np,npoly(10),xpoly(100,10),ypoly(100,10),
     1            polyf,use(10),ispoly
c first convert rlong to -180/180 (or leave in this, or 0/360)
      if(rlong.lt.-180) rlong = rlong + 360
c now make rlong2 fall into the other system than rlong (unless rlong is
c between 0 and 180)
      if(rlong.lt.0) rlong2 = rlong + 360
      if(rlong.gt.180) rlong2 = rlong - 360
      do 5 ip=1,np
      if(.not.use(ip)) then
c polygon is one we should not be in; test to see if we are, and if so set
c iok to 0 and return - check all such before seeing if we might also be
c in a polygon we should be
         do 3 i=1,npoly(ip)
            xu(i) = xpoly(i,ip)
            yu(i) = ypoly(i,ip)
 3       continue
	 if(inpoly(rlong,rlat,xu,yu,npoly(ip)).ne.0.or.
     1      inpoly(rlong2,rlat,xu,yu,npoly(ip)).ne.0) then
	    iok=0
	    return
	 endif
      endif
 5    continue
      ianyok=0
      do 15 ip=1,np
      if(use(ip)) then
c polygon is one we should be in; test to see if we are, and if so set
c iok to 1 and return
         ianyok = ianyok+1
         do 13 i=1,npoly(ip)
            xu(i) = xpoly(i,ip)
            yu(i) = ypoly(i,ip)
 13      continue
         if(inpoly(rlong,rlat,xu,yu,npoly(ip)).ne.0.or.
     1      inpoly(rlong2,rlat,xu,yu,npoly(ip)).ne.0) then
	    iok=1
	    return
	 endif
      endif
 15   continue
c not inside any polygons; set iok to 0 if there are any we should have
c been in
      iok = 1
      if(ianyok.gt.0) iok = 0
      return
      end

c   program oclook
c  looks at model values: either
c     prints out values for a particular place
c     outputs grid within an area (for plotting)
c     outputs values within an area
c
c
      logical*1 ispoly,use
      character*1 modo,fingrd
      character*4 dsym
      character*80 mdfile,dumm
      character*80 polyf
      character*50 mdnam
      character*40 stnam
      complex amp,toloc,phasor,temp,cz
      dimension i1(2),i2(2)
c  common block holds polygon file information
      common/polinf/np,npoly(10),xpoly(100,10),ypoly(100,10),
     1            polyf,use(10),ispoly
      common /modpar/mdfile,dsym,icte(6),mdnam
      common /modlim/tlat,blat,wlong,elong,latc,longc
      phasor(toloc) =
     1 cmplx(cabs(toloc),57.2958*atan2(aimag(toloc),real(toloc)))
      data dr/.0174532935/,rd/57.29577951/,tpi/6.283185307/
      data ispoly/.false./
      data cz/(0.,0.)/
      data fingrd/'c'/
      data stnam/'  Interpolated ocean-tide value         '/
      if(iargc().lt.4) then
	 write(6,100)
 100     format('usage: oclook modelfile lat long d',/,
     1          ' or    oclook modelfile lat long o',/,
     2    ' or    oclook modelfile slat nlat wlong elong g',/,
     3    ' or    oclook modelfile slat nlat wlong elong a ',/,
     4    ' or    oclook modelfile slat nlat wlong elong p ',/,
     5    ' or    oclook modelfile slat nlat wlong elong r ',/,
     6    ' or    oclook modelfile slat nlat wlong elong i ',/,
     7    ' (in all cases, a polyfile may be put on the end)')
	 stop
      endif
      call getarg(1,mdfile)
      if(iargc().eq.4.or.iargc().eq.5) then
         call getarg(2,dumm)
         read(dumm,102) rlato
 102     format(f10.0)
         call getarg(3,dumm)
         read(dumm,102) rlong
         call getarg(4,modo)
         if(iargc().eq.5) then
            ispoly = .true.
            call getarg(5,polyf)
         endif
      endif
      if(iargc().ge.6) then
         call getarg(2,dumm)
         read(dumm,102) slat
         call getarg(3,dumm)
         read(dumm,102) rnlat
         call getarg(4,dumm)
         read(dumm,102) ftlong
         call getarg(5,dumm)
         read(dumm,102) rilong
         call getarg(6,modo)
         if(iargc().eq.7) then
            ispoly = .true.
            call getarg(7,polyf)
         endif
      endif
c
c  done with getting arguments
c
      if(modo.eq.'d') then
	 fingrd = 'c'
         call ocmodl(rlato,rlong,fingrd,amp)
         call celfnd(rlong,rlato,x,y,i,j,ind)
	 write(6,104) i,j,ind,x,y
 104     format('Cell indices are ',i5,i5,' (',i7,')',
     1       ' with fractional locations ',2f6.3)
	 if(amp.ne.cz) write(6,106) amp,phasor(amp)
	 if(amp.eq.cz) write(6,107)
 106     format('Cell amps (R&I,[amp&ph]) are ',2f10.4,/,' [',
     1          2f10.4,' ]')
 107     format('No ocean in this cell')
	 fingrd = 'F'
         call ocmodl(rlato,rlong,fingrd,amp)
	 if(amp.ne.cz) write(6,108) amp,phasor(amp)
	 if(amp.eq.cz) write(6,109)
 108     format('Fine-grid (interpolated) amps (R&I,[amp&ph]) are ',
     1      2f10.4,/,' [',2f10.4,' ]')
 109     format('Interpolated tide is zero')
	 if(ispoly) then
           call chkgon(rlong,rlato,iok)
	   if(iok.eq.0) write(6,110)
 110       format('Point would be excluded by polygon')
         endif
      elseif(modo.eq.'o') then
         fingrd = 'F'
         call ocmodl(rlato,rlong,fingrd,amp)
	 if(ispoly) then
	    call chkgon(rlong,rlato,iok)
	    if(iok.eq.0) amp = cz
         endif
	 if(amp.eq.cz) then
            write(6,119)
 119        format('Tide is zero or excluded by polygon')
	 endif
	 if(amp.ne.cz) then
            write(6,121) 'S',stnam, rlato, rlong, ht
 121        format(a1,2x,a40,3x,f10.4,f10.4,f10.0)
            write(6,123) 'O',dsym,(icte(j),j=1,6),mdnam
 123        format(a1,1x,a4,5x,6i2,5x,a50)
            write(6,125)
 125        format('L g          Phases are Greenwich, lags negative')
            write(6,127)
 127        format('X')
            amp = conjg(amp)
            amp = phasor(amp)
            write(6,129) amp
 129        format('o',9x,2f10.4)
	 endif
c
c this section outputs either the grid cells or the tidal values in the
c cells, within the region specified on the command line
c
      else
         call ocmodl(0.,0.,fingrd,amp)
	 if(rilong.lt.ftlong) rilong=rilong+360
         call fndgde(ftlong,rilong,slat,rnlat,il,ih,jl,jh)
         if(il.eq.0.and.ih.eq.0) then
            write(6,132)
 132        format('Area is outside model')
	    stop
         endif
c following code takes care of case where longitudes specified span
c edge of model
	 if(ih.lt.il) then
	    ngrs = 2
	    i1(1) = 1
	    i2(1) = ih
	    i1(2) = il
	    i2(2) = longc
	 elseif(ih.eq.il) then
	    ngrs = 1
	    i1(1) = 1
	    i2(1) = longc
	 else
	    ngrs = 1
	    i1(1) = il
	    i2(1) = ih
	 endif
	 dlat = (tlat-blat)/latc
	 dlong = (elong-wlong)/longc
	 do 13 k=1,ngrs
	 do 17 i=i1(k),i2(k)
	 do 11 j=jl,jh
	 clat = tlat - j*dlat - dlat/2
	 clong = wlong + (i-1)*dlong + dlong/2
	 if(clong.gt.180) clong = clong - 360
         call ocmodl(clat,clong,fingrd,amp)
	 if(ispoly) then
           call chkgon(clong,clat,iok)
	   if(iok.eq.0) amp=cz
         endif
	 if(amp.ne.cz) then
	    temp = amp
            toloc = phasor(amp)
	    if(modo.eq.'r') write(6,140) clong,clat,real(amp)
	    if(modo.eq.'i') write(6,140) clong,clat,aimag(amp)
	    if(modo.eq.'a') write(6,140) clong,clat,real(toloc)
	    if(modo.eq.'p') write(6,140) clong,clat,aimag(toloc)
 140        format(2f10.4,g14.6)
	    if(modo.eq.'g') then
               write(6,142) clong-dlong/2,clat-dlat/2
               write(6,142) clong-dlong/2,clat+dlat/2
               write(6,142) clong+dlong/2,clat+dlat/2
               write(6,142) clong+dlong/2,clat-dlat/2
               write(6,142) clong-dlong/2,clat-dlat/2
               write(6,*) '-100 100'
 142           format(2f10.4)
            endif
	 endif
 11      continue
 17      continue
 13      continue
      endif
      stop
      end

      subroutine lndsea(rlat,rlong,lnd)
c   for given north latitude and east longitude (in degrees) returns
c  the flag lnd = 1 if land, 2 if water (cf paul revere)
c    ***calls ibit
c
      save iwd
      integer*4 iwd
      character*10 filnam
      dimension iwd(291600)
      data ifirst/0/
      data filnam/'lndsea.dat'/
C      character*50 filnam
C      data filnam/'/users/agnew/projects/tidload/converd/lndsea.dat'/
      if(ifirst.ne.1) then
c  on first call, open the file for random access
         ifirst = 1
         call readls(iwd,filnam)
      endif     
      lnd = 2
      rlong2 = rlong
      if(rlong.lt.0) rlong2 = rlong + 360.
      if(rlong.gt.360) rlong2 = rlong - 360.
      clat = 90-rlat
      ilat = int(12*clat)
      ilong = int(12*rlong2)
      ind = 135*32*ilat + ilong
      nwd = ind/32 + 1
      nbit = mod(ind,32) + 1 
      iv = ibit(iwd(nwd),nbit)
      if(iv.eq.1) lnd = 1
      return
      end
      function ibit(id,n)
c
c  function to return the n-th bit (counting to the right) of a long
c  integer id
c
c    ***calls system routine and - this performs a bitwise and on
c       its two arguments
c
      save ibp,ifl
      integer*4 id,ibp(32),it
      data ifl/0/
      if(ifl.eq.1) go to 3
c  on first call, set up an array of integers, each with exactly one bit
c  set at successively lower values. ibp(1) should have only its highest
c  bit set; that this is true should be verified for each machine
      ifl = 1
      ibp(32) = 1
      do 1 i=2,32
 1    ibp(33-i) = 2*ibp(34-i)
 3    it = ispand(id,ibp(n))
      ibit = 0
      if(it.ne.0) ibit = 1
      return
      end

      subroutine lodout(cload,stnam,rlat,rlam,ht,modo)
c  puts the data into a single ASCII rescaled file for all
c  constituents, in order of frequency. Loads are written out in
c  amp and local or Greenwich phase, lags neg
c
      character*80 stnam,mdfile
      character*80 grname
      character*80 polnam
      character*50 mdnam
      character*24 dates
      character*4 dsym
      character*1 modo,statgr,alpoly
      complex cload,toloc,phasor,cmp,dumm
      dimension cload(9),cmp(3)
      common/modpar/mdfile,dsym,icte(6),mdnam
      common/grinf/nring,rin(10),rout(10),rsz(10),statgr(10),grname
      common/polynm/polnam,alpoly
      common/coninf/dist,close,clat,clong,numnf,clnf,farnf
      phasor(dumm) =
     1 cmplx(cabs(dumm),57.2958*atan2(aimag(dumm),real(dumm)))
      data dr/.0174532935/
      data luo/6/
      write(luo,201) 'S',stnam, rlat, rlam, ht
 201  format(a1,2x,a40,3x,f10.4,f10.4,f10.0)
      write(luo,203) 'O',dsym,(icte(j),j=1,6),mdnam
 203  format(a1,1x,a4,5x,6i2,5x,a50)
      write(luo,205) 'G',grname
 205  format(a1,2x,a78)
      do 3 i=1,nring
      if(statgr(i).eq.'F') write(luo,207) rin(i),rout(i),rsz(i)
 207  format('G    Rings from ',f6.2,' to ',f6.2,' with spacing ',
     1 f4.2,' - detailed grid used')
      if(statgr(i).eq.'C') write(luo,209) rin(i),rout(i),rsz(i)
 209  format('G    Rings from ',f6.2,' to ',f6.2,' with spacing ',
     1 f4.2,' - ocean model grid used')
 3    continue
      if(alpoly.ne.'N') then
         write(luo,211) polnam
 211     format('P',1x,a78)
         if(alpoly.eq.'+') write(luo,212)
 212     format('P   all polygon areas included')
         if(alpoly.eq.'-') write(luo,213)
 213     format('P   all polygon areas excluded')
         if(alpoly.eq.'Y') write(luo,214)
 214     format('P   polygon areas included and excluded as in file')
      endif
c following three lines depend on a specific routine, which returns time
c information in string   dates
      call fdate(dates)
      write(luo,219) dates
 219  format('C   Version 3.0 of load program, run at ',a24)
      write(luo,221) close,clat,clong
 221  format('C   closest nonzero load was ',f6.2,' degrees away, at',
     1 2f8.2)
      if(numnf.ne.0) write(luo,223) numnf,clnf,farnf
 223  format('C   ',i6,' zero loads found where ocean present, range',
     1 f7.2,'-',f7.2,' deg')
      if(modo.eq.'g') write(luo,225)
 225  format('L g          Phases are Greenwich, lags negative')
      if(modo.eq.'l') write(luo,227)
 227  format('L l          Phases are local, lags negative')
      write(luo,231)
 231  format('X')
      isp = icte(1)
      toloc = cmplx(cos(dr*isp*rlam),sin(dr*isp*rlam))
      if(modo.eq.'g') toloc = cmplx(1.,0.)
c
c      gravity
c
      cmp(1) = 1.e8*toloc*cload(1)
      dumm = conjg(cmp(1))
      cmp(1) = phasor(dumm)
      write(luo,235) cmp(1)
 235  format('g',9x,2f10.4)
c
c      displacement (output as E N Z)
c
c  change sign of N and E (see CJ II-143, 5 Jan 82)
      cmp(1) = -1.e3*toloc*cload(4)
      cmp(2) = -1.e3*toloc*cload(3)
      cmp(3) =  1.e3*toloc*cload(2)
      do 5 i =1,3
      dumm = conjg(cmp(i))
 5    cmp(i) = phasor(dumm)
      write(luo,237) cmp
 237  format('d',9x,6f10.4)
c
c      tilt (output as E N)
c
      cmp(1) = 1.e9*toloc*cload(6)
      cmp(2) = 1.e9*toloc*cload(5)
      do 7 i = 1,2
      dumm = conjg(cmp(i))
 7    cmp(i) = phasor(dumm)
      write(luo,239) cmp(1),cmp(2)
 239  format('t',9x,4f10.4)
c
c      strain (output as E, N, EN shear)
c
      cmp(1) = 1.e9*toloc*cload(8)
      cmp(2) = 1.e9*toloc*cload(7)
      cmp(3) = 1.e9*toloc*cload(9)
      do 9 i = 1,3
      dumm = conjg(cmp(i))
 9    cmp(i) = phasor(dumm)
      write(luo,241) cmp
 241  format('s',9x,6f10.4)
 13   continue
      return
      end

      subroutine celfnd(rlong,rlato,x,y,i,j,ind)
c  returns the cell index (as i and j also ind), and
c  fractional position within a cell, for a given long
c  and lat (in degrees)
c
      common/modlim/tlat,blat,wlong,elong,latc,longc
c  check to see that we are within model
      if(rlato.gt.tlat.or.rlato.lt.blat) then
	 ind = 0
	 return
      endif
      dlong = amod(rlong-wlong,360.)
      if(dlong.lt.0) dlong = dlong + 360
      if(dlong.gt.elong-wlong) then
	 ind = 0
	 return
      endif
c  put rlong into the range of longitudes that are specified.
      x = (longc*dlong)/(elong-wlong)
      y = (latc*(tlat-rlato))/(tlat-blat)
      i= int(x) + 1
      j= int(y)
      x = x - i + .5
      y = j - y + .5
      ind = i + longc*j
      return
      end

      subroutine shells(x,k,n)
c  sorts an array x, of length n, sorting upward, and returns
c  an array k which may be used to key another array to the
c  sorted pattern (i.e., if we had an array f to which x 
c  corresponded before sorting, then after calling shells,
c  f(k(1)) will be the element of f corresponding to the
c  smallest x, f(k(2)) the next smallest, and so on.
c   revised 29-dec-82 so k is sorted in turn, the values of
c  k that point to identical values of x being put in increasing
c  order
c
c    calls no other routines
c
      dimension x(n),k(n)
      igap = n
      do 1 i = 1,n
 1    k(i) = i
 5    if(igap.le.1) go to 25
      igap = igap/2
      imax = n - igap
 10   iex = 0
      do 20 i = 1,imax
      ipl = i + igap
      if(x(i).le.x(ipl)) go to 20
      sv = x(i)
      ik = k(i)
      x(i) = x(ipl)
      k(i) = k(ipl)
      x(ipl) = sv
      k(ipl) = ik
      iex = iex + 1
 20   continue
      if(iex.gt.0) go to 10
      go to 5
c
c  now sort k's (for identical values of x, if any)
c
 25   j = 1
 30   if(j.ge.n) return
      if(x(j).eq.x(j+1)) go to 33
      j = j + 1
      go to 30
c  have at least two x's with the same value - see how long this is true
 33   l = j
 35   if(x(l).ne.x(l+1)) go to 38
      l = l + 1
      if(l.lt.n) go to 35
c  j and l are the indices within which x(i) does not change - sort k
 38   igap = l - j + 1
 40   if(igap.le.1) j = l + 1
      if(igap.le.1) go to 30
      igap = igap/2
      imax = l-j+1 - igap
 45   iex = 0
      do 50 i=1,imax
      ipl = i + igap + j - 1
      if(k(i+j-1).le.k(ipl)) go to 50
      ik = k(i+j-1)
      k(i+j-1) = k(ipl)
      k(ipl) = ik
      iex = iex + 1
 50   continue
      if(iex.gt.0) go to 45
      go to 40
      end

      subroutine getgrf(grfile,num,ntot,ngr,fingrd)
      character*80 grfile
      character*80 grname
      character*1 fingrd,statgr
      save newf,llu
      common/green/beg,end,spc,grfn(200,6)
      common/grinf/nring,rin(10),rout(10),rsz(10),statgr(10),grname
      data newf/0/
      if(newf.eq.0) then
	 newf = 1
         llu =  3
         open(unit=llu,file=grfile,status='old',access='sequential',
     $    form="formatted")
	 read(llu,100) grname
 100     format(a)
      endif
      read(llu,102) num,ntot,ngr,beg,end,spc,fingrd
 102  format(3i4,3f10.4,5x,a)
      read(llu,104) ((grfn(ii,j),j=1,6),ii=1,ngr)
 104  format(6e13.6)
      if(fingrd.eq.'f') fingrd = 'F'
      if(fingrd.eq.'c') fingrd = 'C'
      rin(num) = beg
      rout(num) = end
      rsz(num) = spc
      statgr(num) = fingrd
      nring=ntot
      return
      end

c program modcon - converts ASCII files of ocean models to binary (Fortran
c sequential unformatted), or the reverse. The ASCII is read in (or written
c out) via standard input or output; the binary file is specified on the 
c command line
c
c   calls no other routines
c
      character*80 mdfile
      character*50 mdnam
      character*4 dsym
      character*1 cdir
      integer*2 ir1,im1
      dimension ir1(260000),im1(260000)
      common /modpar/mdfile,dsym,icte(6),mdnam
      common /modlim/tlat,blat,wlong,elong,latc,longc
      if(iargc().ne.2) then
	 write(6,100)
 100     format('usage: modcon [f|r] binaryfile',/
     1     'f for ASCII -> binary, r the reverse')
	 stop
      endif
      call getarg(1,cdir)
      if(cdir.ne.'r'.and.cdir.ne.'f') then
         write(6,100)
         stop
      endif
      call getarg(2,mdfile)
      if(cdir.eq.'f') then
         llu =  5
         read(llu,102) dsym
 102     format(a4)
         read(llu,104) (icte(i),i=1,6)
 104     format(6i3)
         read(llu,106) latd,latf
 106     format(2i8)
         read(llu,106) latd2,latf2
         read(llu,106) latd3,latf3
         read(llu,106) latd4,latf4
         read(llu,106) latc,longc
         read(llu,108) mdnam
 108     format(a50)
         read(llu,110) (ir1(i),i=1,latc*longc)
 110     format(10i7)
         read(llu,110) (im1(i),i=1,latc*longc)
         llu =  2
         open(unit=llu,file=mdfile,status='unknown',access=
     $       'sequential',form="unformatted")
         write(llu) dsym
         write(llu) (icte(i),i=1,6)
         write(llu) latd,latf
         write(llu) latd2,latf2
         write(llu) latd3,latf3
         write(llu) latd4,latf4
         write(llu) latc,longc
         write(llu) mdnam
         write(llu) (ir1(i),i=1,latc*longc)
         write(llu) (im1(i),i=1,latc*longc)
         close(llu)
      endif
      if(cdir.eq.'r') then
         llu =  2
         open(unit=llu,file=mdfile,status='old',access=
     $       'sequential',form="unformatted")
         read(llu) dsym
         read(llu) (icte(i),i=1,6)
         read(llu) latd,latf
         read(llu) latd2,latf2
         read(llu) latd3,latf3
         read(llu) latd4,latf4
         read(llu) latc,longc
         read(llu) mdnam
         read(llu) (ir1(i),i=1,latc*longc)
         read(llu) (im1(i),i=1,latc*longc)
         close(llu)
         llu =  6
         write(llu,102) dsym
         write(llu,104) (icte(i),i=1,6)
         write(llu,106) latd,latf
         write(llu,106) latd2,latf2
         write(llu,106) latd3,latf3
         write(llu,106) latd4,latf4
         write(llu,106) latc,longc
         write(llu,108) mdnam
         write(llu,110) (ir1(i),i=1,latc*longc)
         write(llu,110) (im1(i),i=1,latc*longc)
      endif
      stop
      end

c  program hartid
c    finds tides by summing harmonics; the amp and phase of these are
c  specified in subroutine admfnd
c
c    $calls admget,tdfrph,recurs,spline,shells
c
      character*40 dumm
      double precision f,p,dr,pi,scr
      dimension a(67),f(67),p(67),x(600),hc(134),scr(201),wf(67)
      common/date/it(5)
      data nt/67/,dr/.01745329252d0/,pi/3.1415926535898d0/,irli/1/
      data luo/6/
      if(iargc().lt.1.or.iargc().gt.7) then
	 write(luo,100)
 100  format('Usage: hartid y d h m s num samp',/,
     1  '  harmonics file read from standard input',/,
     2  '  results written to standard output')
	 stop
      endif
      call getarg(1,dumm)
      read(dumm,102) it(1)
 102  format(i4)
      call getarg(2,dumm)
      read(dumm,102) it(2)
      call getarg(3,dumm)
      read(dumm,102) it(3)
      call getarg(4,dumm)
      read(dumm,102) it(4)
      call getarg(5,dumm)
      read(dumm,102) it(5)
      call getarg(6,dumm)
      read(dumm,104) irnt
 104  format(i6)
      call getarg(7,dumm)
      read(dumm,106) samp
 106  format(f7.0)
      call admfnd(a,f,p,nt)
c  set up for first recursion, and normalize frequencies
      do 23 i=1,nt
      p(i) = dr*p(i)
      f(i) = samp*pi*f(i)/43200.d0
 23   wf(i) = f(i)
 31   irhi = min(irli+599,irnt)
      np = irhi - irli + 1
c set up harmonic coefficients, compute tide, and write out
      do 33 i=1,nt
      hc(2*i-1) = a(i)*dcos(p(i))
 33   hc(2*i)  = -a(i)*dsin(p(i))
      call recurs(x,np,hc,nt,wf,scr)
      write(6,110) (x(i),i=1,np)
 110  format(6g13.5)
      if(irhi.eq.irnt) go to 37
      irli = irhi + 1
c  reset phases to the start of the new section
      do 36 i=1,nt
      p(i) = p(i) + np*f(i)
 36   p(i) = dmod(p(i),2.d0*pi)
      go to 31
 37   continue
      stop
      end

c  program nloadf
c
c   computes the load tide caused by the oceans, using a station-centered
c  grid and integrated green functions.
c    calls:  ignewt (for the newtonian green functions)
c            ocmodl (for the ocean load - calls ocstart to read model in)
c            getcl  (to get command-line parameters)
c            getgrf (to get Green functions)
c            lodout (to write results to standard output)
c
      character*80 stnam,mdfile,grfile
      character*50 mdnam
      character*1 modo,fingrd
      complex disp,grav,tilt,str,amp,cmp,cload
      dimension disp(3),tilt(2),str(3),cload(9)
c  matrix of green functions holds: vert disp, horiz disp, elastic gravity,
c                                   elastic tilt, e theta theta, e lam lam
      common /green/beg,end,spc,grfn(200,6)
      common /modpar/mdfile,dsym,icte(6),mdnam
      common /stloc/ct,st,rlam,ht
      common/coninf/dist,close,clat,clong,numnf,clnf,farnf
      data dr/.0174532935/,rd/57.29577951/,tpi/6.283185307/,minaz/150/,
     1 an/6.371e6/,cz/(0.,0.)/,rho/1.025e3/,lu/4/
      data close/0.0/,numnf/0/,nclose/0/
      an = 1./an
      call getcl(stnam,rlat,rlam,ht,mdfile,grfile,modo,distm)
      ct = cos(dr*(90.-rlat))
      st = sin(dr*(90.-rlat))
      grav = cz
      tilt(1) = cz
      tilt(2) = cz
      do 1 i=1,3
      disp(i) = cz
 1    str(i) = cz
      distbr = endn
c  convolutions start here - read in Green functions, which come in
c  ntot sections; num is the current one, fingrd is whether or not to
c  use the detailed land-sea grid
 3    call getgrf(grfile,num,ntot,nf,fingrd)
      stp = dr*spc
c  if this is the first convolution interval see if (1) there is ocean at
c  the station location and (2) if it is below sea level. If both are true,
c  compute the gravity load (only) for a disk from distance 0 to the start
c  of the first integrated Green function
      if(num.eq.1) then
         call ocmodl(rlat,rlam,fingrd,amp)
	 if(amp.ne.cz.and.ht.lt.0) then
            amp = rho*amp
	    del=dr*beg/2
            call ignewt(del,2*del,g,t)
            grav = grav + g*amp*tpi
	    close = 0.
	    clat = rlat
	    clong = rlam
	    nclose = 1
	 endif
      endif
c
c  loop through distance begins here
c
      do 13 ii=1,nf
      dist = beg + (ii-1.)*spc
      del = dr*dist
      cd = cos(del)
      sd = sin(del)
      call ignewt(del,stp,g,t)
      g = g + grfn(ii,3)
      t = t + grfn(ii,4)
      u = grfn(ii,1)
      v = grfn(ii,2)
      ett = grfn(ii,5)
      ell = grfn(ii,6)
c find the number of azimuth steps (scaled with sin(del), but kept above
c some minimum)
      naz = 360.*sd
      if(dist.lt.180.) naz = max0(naz,minaz)
      azstp = tpi/naz
      azstpd = 360./naz
      azimuth = azstpd/2
      caz = cos(azstp/2)
      saz = sin(azstp/2)
      saztp = sin(azstp)
      caztp = cos(azstp)
      stpfac = 2*saz
c
c  loop through azimuth begins here
c
      do 11 jj=1,naz
c do the spherical trigonometry to find the cell lat and long
      cb = cd*ct + sd*st*caz
      if(abs(cb).gt.1) cb = cb/abs(cb)
      sb = sqrt(1.-cb*cb)
      rlato = 90 - rd*acos(cb) 
      rlong = 0.
c  if near the north pole leave longitude at zero- otherwise find it
      if(sb.gt.1.e-3) then
         sb = 1./sb
         sg = sd*saz*sb
         cg = (st*cd - sd*ct*caz)*sb
         rlong = rlam + rd*atan2(sg,cg)
      endif
      call ocmodl(rlato,rlong,fingrd,amp)
      amp = rho*amp
      if(amp.ne.(0.,0.).and.modo.ne.'m') then
c if this is the first nonzero amplitude, save the distance and location
	 if(nclose.eq.0) then
	    close = dist
	    clat = rlato
	    clong = rlong
	    nclose = 1
         endif
         cmp = amp*stpfac
c  compute the loads.  disp is vert,ns,ew; tilt is ns,ew;
c                      strain is ns,ew,ne shear
         disp(1) = disp(1) + u*amp*azstp
         disp(2) = disp(2) + v*caz*cmp
         disp(3) = disp(3) + v*saz*cmp
         grav = grav + g*amp*azstp
         tilt(1) = tilt(1) + t*caz*cmp
         tilt(2) = tilt(2) + t*saz*cmp
         aa = .5*(caz*caz - saz*saz)
         bb = .5*azstp + aa*stpfac
         cc = .5*azstp - aa*stpfac
         str(1) = str(1) + (ett*bb + ell*cc)*amp
         str(2) = str(2) + (ell*bb + ett*cc)*amp
         str(3) = str(3) + (ett-ell)*saz*caz*saztp*caztp*amp
      elseif(amp.ne.(0.,0.).and.modo.eq.'m'.and.dist.le.distm) then
c  otherwise, output locations of cell corners, for later plotting
         call ldbxdr(azimuth,dist,azstpd,spc)
      endif
c  use recursion to step sin and cos of the azimuth
      azimuth = azimuth + azstpd
      xx = saz*caztp + caz*saztp
      caz = caz*caztp - saz*saztp
      saz = xx
 11   continue
 13   continue
      if(num.lt.ntot) go to 3
      if(modo.eq.'m') stop
c
c  done with convolution - add to disk file, and convert to amp and phase
c
      cload(1) = grav
      cload(5) = tilt(1)
      cload(6) = tilt(2)
      do 15 i=1,3
      cload(i+1) = disp(i)
      cload(i+6) = str(i)
 15   continue
      call lodout(cload,stnam,rlat,rlam,ht,modo)
      stop
      end

      subroutine admfnd(amp,f,p,n)
c  Returns the amplitude, frequency, and phase of a set of tidal
c  constituents. n is input as the number wanted, and returned as the number
c  provided.  The constituents used are stored in the arrays idd (doodson
c  number) and tamp (Cartwright-Edden amplitude).  The actual amp and
c  phase of each of these are determined by spline interpolation of the
c  real and imaginary part of the admittance, as specified at a subset
c  of the constituents.
c  The phase is determined for a time set in common block /date/ (see
c  subroutine tdfrph), outside of this subroutine.
c   Note that the arrays f and p must be specified as double precision.
c
c   $$$$calls tdfrph,spline,eval,shells
c
      character*1 ipht
      double precision f,p,fr,pr
      dimension amp(1),f(1),p(1)
c  arrays containing information about all stored constituents
      dimension idd(6,67),tamp(67)
c  arrays containing information about the subset whose amp and phase may
c  be specified, and scratch arrays for the spline routines
c   at most 20 constituents may be specified.
      dimension rl(20),aim(20),rf(20),key(20),scr(20),
     1 zdi(20),zdr(20),di(20),dr(20),sdi(20),sdr(20),tdi(20),tdr(20),
     2 idtst(6)
      data dtr/.017453293/,pi/3.14159265/
      data nt/67/,ncon/20/
      data rl/20*0.0/,aim/20*0.0/,rf/20*0.0/
      data zdi/20*0.0/,zdr/20*0.0/,di/20*0.0/,dr/20*0.0/
      data sdi/20*0.0/,sdr/20*0.0/,tdi/20*0.0/,tdr/20*0.0/
      data tamp/
     1  .63192, .29400, .12099, .07966, .02383,-.02358, .02298, .01932,
     2 -.01786, .01720, .01601, .00467,-.00466,-.00451, .00447, .00447,
     3  .00259,-.00246,-.00218, .00197, .00195, .00192,-.00190, .00180,
     4  .36878,-.26221,-.12203,-.05020, .05001,-.04945, .02062, .02062,
     5  .01129,-.00954,-.00947,-.00802, .00741,-.00730, .00723,-.00714,
     6 -.00664, .00525, .00414, .00409, .00395, .00394, .00343, .00342,
     7  .00293, .00289, .00216, .00194,-.00194,-.00180,-.06663,-.03518,
     8 -.02762,-.01276,-.00673,-.00583,-.00529,-.00288,-.00258, .00765,
     9  .00210, .00100,-.00043/
      data idd/
     1 2, 0, 0, 0, 0, 0,  2, 2,-2, 0, 0, 0,  2,-1, 0, 1, 0, 0,  2, 2, 0,
     2 0, 0, 0,  2, 2, 0, 0, 1, 0,  2, 0, 0, 0,-1, 0,  2,-1, 2,-1, 0, 0,
     3 2,-2, 2, 0, 0, 0,  2, 1, 0,-1, 0, 0,  2, 2,-3, 0, 0, 1,  2,-2, 0,
     4 2, 0, 0,  2,-3, 2, 1, 0, 0,  2, 1,-2, 1, 0, 0,  2,-1, 0, 1,-1, 0,
     5 2, 3, 0,-1, 0, 0,  2, 1, 0, 1, 0, 0,  2, 2, 0, 0, 2, 0,  2, 2,-1,
     6 0, 0,-1,  2, 0,-1, 0, 0, 1,  2, 1, 0, 1, 1, 0,  2, 3, 0,-1, 1, 0,
     7 2, 0, 1, 0, 0,-1,  2, 0,-2, 2, 0, 0,  2,-3, 0, 3, 0, 0,  1, 1, 0,
     8 0, 0, 0,  1,-1, 0, 0, 0, 0,  1, 1,-2, 0, 0, 0,  1,-2, 0, 1, 0, 0,
     9 1, 1, 0, 0, 1, 0,  1,-1, 0, 0,-1, 0,  1, 2, 0,-1, 0, 0,  1, 0, 0,
     1 1, 0, 0,  1, 3, 0, 0, 0, 0,  1,-2, 2,-1, 0, 0,  1,-2, 0, 1,-1, 0,
     2 1,-3, 2, 0, 0, 0,  1, 0, 0,-1, 0, 0,  1, 1, 0, 0,-1, 0,  1, 3, 0,
     3 0, 1, 0,  1, 1,-3, 0, 0, 1,  1,-3, 0, 2, 0, 0,  1, 1, 2, 0, 0, 0,
     4 1, 0, 0, 1, 1, 0,  1, 2, 0,-1, 1, 0,  1, 2,-2, 1, 0, 0,  1, 0, 2,
     5-1, 0, 0,  1,-1, 2, 0, 0, 0,  1, 3,-2, 0, 0, 0,  1, 1, 1, 0, 0,-1,
     6 1, 1,-1, 0, 0, 1,  1, 4, 0,-1, 0, 0,  1, 0,-2, 1, 0, 0,  1,-4, 2,
     7 1, 0, 0,  1,-2, 2,-1,-1, 0,  0, 2, 0, 0, 0, 0,  0, 1, 0,-1, 0, 0,
     8 0, 2, 0, 0, 1, 0,  0, 3, 0,-1, 0, 0,  0, 1,-2, 1, 0, 0,  0, 2,-2,
     9 0, 0, 0,  0, 3, 0,-1, 1, 0,  0, 2, 0,-2, 0, 0,  0, 2, 0, 0, 2, 0,
     1 3,0,0,0,0,0,  3,-1,0,1,0,0,  3,2,0,0,0,0,  3,0,0,0,-1,0/
      k = 0
      nlp = 0
      ndi = 0
      nsd = 0
      ntd = 0
      read(5,104) ipht
 104  format(a1)
      if(ipht.eq.'l') read(5,106) rlong
 106  format(f8.0)
 13   read(5,108,end=17) idtst,ramp,rph
 108  format(6i2,2f9.0)
c  stop reading on a flag or if arrays are full
      if(idtst(1).eq.-1.or.k.eq.ncon) go to 17
c  see if Doodson numbers match
      do 15 kk=1,nt
      ii = 0
      do 14 i=1,6
 14   ii = ii + iabs(idd(i,kk)-idtst(i))
      if(ii.eq.0) go to 16
 15   continue
c  have a match - put line into array
 16   if(ii.eq.0.and.k.lt.ncon) then
         k = k + 1
         rl(k) = ramp*cos(dtr*rph)/abs(tamp(kk))
         aim(k)= ramp*sin(dtr*rph)/abs(tamp(kk))
c  Now have real and imaginary parts of admittance, scaled by C-E
c  amplitude. Admittance phase is whatever was used in the original
c  expression. (Usually phase is given relative to some reference
c  but amplitude is in absolute units). Next get frequency.
         call tdfrph(idd(1,kk),fr,pr)
         rf(k) = fr
      endif
      go to 13
c  done reading in constituents
c  have specified admittance at a number of points. sort these by frequency
c  and separate diurnal and semidiurnal, recopying admittances to get them in
c  order
 17   call shells(rf,key,k)
      do 21 i=1,k
      if(rf(i).lt.0.5) nlp = nlp + 1
      if(rf(i).lt.1.5.and.rf(i).gt.0.5) ndi = ndi + 1
      if(rf(i).lt.2.5.and.rf(i).gt.1.5) nsd = nsd + 1
      if(rf(i).lt.3.5.and.rf(i).gt.2.5) ntd = ntd + 1
 21   scr(i) = rl(key(i))
      do 23 i=1,k
      rl(i) = scr(i)
 23   scr(i) = aim(key(i))
      do 25 i=1,k
 25   aim(i) = scr(i)
c  now set up splines (8 cases - four species, each real and imag)
c  we have to allow for the case when there are no constituent amplitudes
c  for the long-period or terdiurnal.
      if(nlp.ne.0) call spline(nlp,rf,rl,zdr,scr)
      if(nlp.ne.0) call spline(nlp,rf,aim,zdi,scr)
      call spline(ndi,rf(nlp+1),rl(nlp+1),dr,scr)
      call spline(ndi,rf(nlp+1),aim(nlp+1),di,scr)
      call spline(nsd,rf(nlp+ndi+1),rl(nlp+ndi+1),sdr,scr)
      call spline(nsd,rf(nlp+ndi+1),aim(nlp+ndi+1),sdi,scr)
      if(ntd.ne.0) 
     1   call spline(ntd,rf(nlp+ndi+nsd+1),rl(nlp+ndi+nsd+1),tdr,scr)
      if(ntd.ne.0) 
     1   call spline(ntd,rf(nlp+ndi+nsd+1),aim(nlp+ndi+nsd+1),tdi,scr)
c  evaluate all harmonics using the interpolated admittance
      n = min0(n,nt)
      j = 1
      do 31 i=1,n
      if((idd(1,i).eq.0.and.nlp.eq.0).or.(idd(1,i).eq.3.and.ntd.eq.0))
     1  go to 31
      call tdfrph(idd(1,i),f(j),p(j))
c  equilibrium phase corrections (including to local phase)
      if(idd(1,i).eq.1) p(j) = p(j) + 90.
      if(idd(1,i).eq.3) p(j) = p(j) + 180.
      if(ipht.eq.'l') p(j) = p(j) + idd(1,i)*rlong
      sf = f(j)
      if(idd(1,i).eq.0) re = eval(sf,nlp,rf,rl,zdr)
      if(idd(1,i).eq.0) am = eval(sf,nlp,rf,aim,zdi)
      if(idd(1,i).eq.1) re = eval(sf,ndi,rf(nlp+1),rl(nlp+1),dr)
      if(idd(1,i).eq.1) am = eval(sf,ndi,rf(nlp+1),aim(nlp+1),di)
      if(idd(1,i).eq.2) re =
     1   eval(sf,nsd,rf(nlp+ndi+1),rl(nlp+ndi+1),sdr)
      if(idd(1,i).eq.2) am =
     1   eval(sf,nsd,rf(nlp+ndi+1),aim(nlp+ndi+1),sdi)
      if(idd(1,i).eq.3) re =
     1   eval(sf,ntd,rf(nlp+ndi+nsd+1),rl(nlp+ndi+nsd+1),tdr)
      if(idd(1,i).eq.3) am =
     1   eval(sf,ntd,rf(nlp+ndi+nsd+1),aim(nlp+ndi+nsd+1),tdi)
      amp(j) = tamp(i)*sqrt(re**2+am**2)
      p(j) = p(j) + atan2(am,re)/dtr
      j = j + 1
 31   continue
      n = j - 1
      return
      end

      subroutine getcl(stnam,rlat,rlong,ht,mdfile,grfile,modo,distm)
c  gets parameters needed from command line; stops program if there
c  are too few
      logical*1 ispoly,use
      character*1 modo,alpoly
      character*80 stnam,mdfile,grfile,polyf,dumm,polnam
c  common block holds polygon file information
      common/polinf/np,npoly(10),xpoly(100,10),ypoly(100,10),
     1            polyf,use(10),ispoly
      common/polynm/polnam,alpoly
      data ispoly/.false./,alpoly/'N'/
      if(iargc().lt.7) then
	 write(6,100)
 100     format('usage: nloadf stname lat long ht modelfile',
     1' greenfile mode [dist] [polyfile]'/,'e.g.',/,
     2'nloadf PFO 33.609 -116.455 1280 m2.tpxo2 grn.gb g',/,
     3'nloadf PFO 33.609 -116.455 1280 m2.tpxo2 grn.gb m 5',/,
     4'nloadf PFO 33.609 -116.455 1280 m2.tpxo2 grn.gb g nobaja',/,
     6'mode is g or l for loading, m to output cells (needs a max',
     7' distance in deg')
	 stop
      endif
      call getarg(1,stnam)
      call getarg(2,dumm)
      read(dumm,102) rlat
 102  format(f10.0)
      call getarg(3,dumm)
      read(dumm,102) rlong
      call getarg(4,dumm)
      read(dumm,102) ht
      call getarg(5,mdfile)
      call getarg(6,grfile)
      call getarg(7,modo)
      if(modo.ne.'g'.and.modo.ne.'l'.and.modo.ne.'m') then
         write(6,103)
 103     format('Mode must be g, l (Greenwich or local phase), or m')
         stop
      endif
      if(modo.eq.'m') then
	 if(iargc().lt.8) then
	    write(6,104)
 104        format('Distance needed for mode m')
	    stop
         endif
         call getarg(2,dumm)
         read(dumm,102) distm
	 if(iargc().ge.9) then
	    ispoly = .true.
	    alpoly = 'Y'
	    call getarg(9,polyf)
	 endif
	 if(iargc().eq.10) call getarg(10,alpoly)
	 return
      endif
      if(iargc().eq.7) return
      if(iargc().gt.9) then
         write(6,105) iargc()
 105     format('Too many arguments (',i2,')')
	 stop
      endif
      call getarg(8,polyf)
      ispoly = .true.
      alpoly = 'Y'
      if(iargc().eq.9) call getarg(9,alpoly)
      return
      end

c  program mapcon; converts between binary and ASCII versions of the map files
c
      character*80 mdfil1,mdfil2
      character*1 cdir
      integer*2 index
      integer*4 map
c index is 360x720 integers, map 32x32 bits (64/degree). The following
c dimension and data statements would need to be changed for a different
c cell size and resolution.
      dimension index(259200),map(32)
      data ind/259200/,indfi/32/
      if(iargc().lt.1.or.iargc().gt.3.or.iargc().eq.2) then
	 write(6,100)
 100     format('usage: mapcon r file1 file2',/,
     1     'to convert binary files file1 and file2 to ASCII',/,
     2     'or     mapcon f',/,
     3     'to convert ASCII to the binary files lndsea.bit and',
     4     ' lndsea.ind')
	 stop
      endif
      call getarg(1,cdir)
      if(cdir.ne.'r'.and.cdir.ne.'f') then
         write(6,100)
         stop
      endif
      if(cdir.eq.'r') then
         if(iargc().ne.3) then
	    write(6,100)
            stop
         endif
         call getarg(2,mdfil1)
         call getarg(3,mdfil2)
         llu = 2
	 luo = 6
         open(unit=llu,file=mdfil2,status='old',access=
     $       'sequential',form="unformatted")
         read(llu) index
         close(llu)
	 write(luo,120) index
 120     format(12i6)
         open(unit=llu,file=mdfil1,status='old',access=
     $       'sequential',form="unformatted")
 3       read(llu,end=7) map
	 write(luo,122) map
 122     format(6i12)
	 go to 3
 7       continue
	 close(llu)
      endif
      if(cdir.eq.'f') then
         if(iargc().ne.1) then
	    write(6,100)
            stop
         endif
	 ncells=0
         llu = 5
	 luo = 2
         open(unit=luo,file='lndsea.ind',status='new',access=
     $       'sequential',form="unformatted")
         read(llu,120) index
	 write(luo) index
         close(luo)
         open(unit=luo,file='lndsea.bit',status='new',access=
     $       'sequential',form="unformatted")
 13      read(llu,122,end=17) map
	 ncells = ncells+1
	 write(luo) map
	 go to 13
 17      continue
	 close(luo)
	 write(6,124) ncells,32*ncells
 124  format(i6,' mixed cells written, dimension mapful to ',i9)
      endif
      stop
      end

      subroutine ldbxdr(azimuth,distance,azstp,disstp)
      dimension xx(2,2),yy(2,2)
c  outputs the coordinates (longitude-latitude) of a load cell centered
c  at given azimuth and distance, with dimensions azstp and disstp. The
c  station location is passed to invspt in a common block
      data lu/6/
      do 7 i=1,2
      do 5 j=1,2
      idelsg = 2*i - 3
      ialpsg = 2*j - 3
      cornaz = azimuth+ialpsg*(azstp/2.)
      rad = distance+idelsg*(disstp/2.)
      call invspt(cornaz,rad,b,rlong)
      yy(i,j) = 90-b
      xx(i,j) = rlong
  5   continue
  7   continue
      write(lu,132) xx(1,1),yy(1,1)
      write(lu,132) xx(1,2),yy(1,2)
      write(lu,132) xx(2,2),yy(2,2)
      write(lu,132) xx(2,1),yy(2,1)
      write(lu,132) xx(1,1),yy(1,1)
      write(lu,132) 100.,0.
 132  format(2g14.6)
      return
      end

      subroutine spline(nn,x,u,s,a)
c$$$$ calls no other routines
c  finds array  s  for spline interpolator  eval.
c  nn  number of data points supplied (may be negative, see below)
c  x  array containing x-coordinates where function is sampled.  xx(1),xx(2),...
c     must be a strictly increasing sequence.
c  u  array containing sample values that are to be interpolated.
c  s  output array of 2nd derivative at sample points.
c  a  working space array of dimension at least  nn.
c  if the user wishes to force the derivatives at the ends of the series to     
c  assume specified values, he should put du(1)/dx and du(n)/dx in s1,s2
c  and call the routine with nn=-number of terms in series.  normally a parabola
c  is fitted through the 1st and last 3 points to find the slopes.
c  if less than 4 points are supplied, straight lines are fitted.
      dimension x(1),u(1),s(1),a(1)
c
      q(u1,x1,u2,x2)=(u1/x1**2-u2/x2**2)/(1.0/x1-1.0/x2)
c
      n=iabs(nn)
      if (n.le.3) go to 5000
      q1=q(u(2)-u(1),x(2)-x(1),u(3)-u(1),x(3)-x(1))
      qn=q(u(n-1)-u(n),x(n-1)-x(n),u(n-2)-u(n),x(n-2)-x(n))
      if (nn.gt.0) go to 1000
      q1=s(1)
      qn=s(2)
 1000 s(1)=6.0*((u(2)-u(1))/(x(2)-x(1)) - q1)
      n1= n - 1
      do 2000 i=2,n1
      s(i)= (u(i-1)/(x(i)-x(i-1)) - u(i)*(1.0/(x(i)-x(i-1))+
     + 1.0/(x(i+1)-x(i))) + u(i+1)/(x(i+1)-x(i)))*6.0
 2000 continue
      s(n)=6.0*(qn + (u(n1)-u(n))/(x(n)-x(n1)))
      a(1)=2.0*(x(2)-x(1))
      a(2)=1.5*(x(2)-x(1)) + 2.0*(x(3)-x(2))
      s(2)=s(2) - 0.5*s(1)
      do 3000 i=3,n1
      c=(x(i)-x(i-1))/a(i-1)
      a(i)=2.0*(x(i+1)-x(i-1)) - c*(x(i)-x(i-1))
      s(i)=s(i) - c*s(i-1)
 3000 continue
      c=(x(n)-x(n1))/a(n1)
      a(n)=(2.0-c)*(x(n)-x(n1))
      s(n)=s(n) - c*s(n1)
c  back substitiute
      s(n)= s(n)/a(n)
      do 4000 j=1,n1
      i=n-j
      s(i) =(s(i) - (x(i+1)-x(i))*s(i+1))/a(i)
 4000 continue
      return
c  series too short for cubic spline - use straight lines.
 5000 do 5500 i=1,n
 5500 s(i)=0.0
      return
      end
      function eval(y,nn,x,u,s)
c$$$$ calls no other routines
c  performs cubic spline interpolation of a function sampled at unequally
c  spaced intervals.  the routine spline  should be called to set up the array s
c  y  the coordinate at which function value is desired.
c  nn  number of samples of original function.
c  x  array containing sample coordinates. the sequence x(1),x(2).....x(nn)     
c     must be strictly increasing.
c  u  array containing samples of function at the coordinates x(1),x(2)...      
c  s  array containing the 2nd derivatives at the sample points.  found by the  
c     routine  spline, which must be called once before beginning interpolation.
c  if  y  falls outside range(x(1),x(nn))  the value at the nearest endpoint    
c  of the series is used.
      dimension x(1),u(1),s(1)
      common /startx/ istart
      data istart/1/
c
      nn=iabs(nn)
      if (y.lt.x(1))  go to 3000
      if (y.gt.x(nn)) go to 3100
c  locate interval (x(k1),x(k))  containing y
      if (y-x(istart)) 1200,1000,1000
c  scan up the x array
 1000 do 1100 k=istart,nn
      if (x(k).gt.y) go to 1150
 1100 continue
 1150 k1=k-1
      go to 1500
c  scan downwards in x array
 1200 do 1300 k=1,istart
      k1=istart-k
      if (x(k1).le.y) go to 1350
 1300 continue
 1350 k=k1+1
 1500 istart=k1
c  evaluate interpolate
      dy=x(k)-y
      dy1=y-x(k1)
      dk=x(k)-x(k1)
      deli=1./(6.0*dk)
      ff1=s(k1)*dy*dy*dy
      ff2=s(k)*dy1*dy1*dy1
      f1=(ff1+ff2)*deli
      f2=dy1*((u(k)/dk)-(s(k)*dk)/6.)
      f3=dy*((u(k1)/dk)-(s(k1)*dk)/6.0)
      eval=f1+f2+f3
      return
c  out of range.  substitute end values.
 3000 eval=u(1)
      return
 3100 eval=u(nn)
      return
      end

      subroutine recurs(x,n,hc,nf,om,scr)
      double precision sc,scr
c  does sin and cos recursion to fill in data x, of length n, for
c  nf sines and cosines with frequenciies om (normalized so the
c  nyquist is pi). hc contains alternating cosine and sine coefficients
c  scr is a scratch array of length 3*nf (n.b. - it is double precision)
c
      dimension x(1),hc(1),scr(1),om(1)
c  set up for start of recursion by computing harmonic values
c  at start point and just before it
      do 3 i = 1,nf
      scr(3*i-2) = hc(2*i-1)
      scr(3*i-1) = hc(2*i-1)*cos(om(i)) -hc(2*i)*sin(om(i))
 3    scr(3*i) = 2.*dcos(dble(om(i)))
c  do recursion over data
      do 7 i = 1,n
      x(i) = 0.
c  do recursive computation for each harmonic
      do 5 j  = 1,nf
      x(i) = x(i) + scr(3*j-2)
      sc = scr(3*j-2)
      scr(3*j-2) = scr(3*j)*sc-scr(3*j-1)
 5    scr(3*j-1) = sc
 7    continue
      return
      end

      subroutine ignewt(del,stp,grav,tilt)
c  returns the integrated green function for newtonian gravity and tilt;
c the function is the integral over the interval cntered at del with
c width stp (ie, the interval [del-stp/2,del+stp/2],
c del and stp both being in radians
c  the height correction is included in the green functions,
c the station height in meters being passed as ht in the common block
c stloc
c
c  $$$$$$calls only system routines
c
      save iflg,eps,eps1,eps2,eps3,g2,em
      common/stloc/ct,st,rlam,ht
      data gn/6.67e-11/,a/6.371e6/,iflg/0/
c  on first call do part of height correction, and find constant parts
      if(iflg.eq.0) then
         iflg = 1
         eps = ht/a
         eps1=1.+eps
         eps2=eps*eps
         eps3=2*eps1*eps1
         g2 = 2*gn/(1.+1.5*eps)
	 g = 9.7803327*(1+.005279*ct*ct) - 3.08e-6*ht
	 em = gn/g
      endif
      c1 = sin(.25*stp)
      sthl = .5*stp
c sign for gravity makes + acceleration up
c use different approximations if < or > 0.05 rad (2.9 deg)
      if(del.ge.0.05) then
        grav = -g2*cos(del/2.)*c1*(1. + eps/(cos(sthl)-cos(del)))
        tilt = em*(-2.*sin(del/2.)*c1 +
     1    alog(tan((del+sthl)/4.)/tan((del-sthl)/4.)))
      endif
      if(del.lt.0.05) then
         d1 = del + stp/2
         d2 = del - stp/2
         grav = -gn*(eps1*d1*d1-2*eps)/(eps3*sqrt(eps1*d1*d1+eps2))
         grav = grav 
     1         + gn*(eps1*d2*d2-2*eps)/(eps3*sqrt(eps1*d2*d2+eps2))
         tilt = em*(d2/sqrt(eps2+d2*d2) - d1/sqrt(eps2+d1*d1) + 
     1      alog( (d1+sqrt(eps2+d1*d1))/(d2+sqrt(eps2+d2*d2)) ) )
      endif
      return
      end

      subroutine invspt(alp,del,b,rlong)
c  solves the inverse spherical triangle problem - given a station whose
c  colatitude is t, and east longitude rlam (in degrees), returns the
c  colatitude b and east longitude rlong of the place which is at a distance
c  of delta degrees and at an azimuth of alp (clockwise from north).
c  the common block stloc holds the cosine and sine of the station colatitude,
c  and its east longitude.
      common/stloc/ct,st,rlam,ht
      data dtr/.01745329251/
      ca = cos(alp*dtr)
      sa = sin(alp*dtr)
      cd = cos(del*dtr)
      sd = sin(del*dtr)
      cb = cd*ct + sd*st*ca
      sb = sqrt(1.-cb*cb)
      b = acos(cb)/dtr
      if(sb.le.1.e-3) then
c  special case - the point is at the poles
	 rlong = 0
	 return
      endif
      sg = sd*sa/sb
      cg = (st*cd-sd*ct*ca)/sb
      g = atan2(sg,cg)/dtr
      rlong = rlam + g
      return
      end

      subroutine ocstart(ir1,im1)
c
c    Reads in an ocean model, from a filename passed in common.  The arrays
c  ir1 and im1 hold the model values (real and imaginary parts); the following
c  are returned also (in another common):
c     tlat   latitude (N) of top edge of model grid
c     blat   latitude ( ) of bottom edge of model grid
c     elong   longitude (E) of "right" edge of model grid
c     wlong   longitude (E) of "left" edge of model grid
c     latc   number of cells EW
c     longc   number of cells NS
c
c  other auxiliary information is passed to other routines in common block
c   modpar, which also contains the file name
c
c   This version reads a file of model values, which should contain:
c     bytes 1-4  the Darwin symbol (a4)
c     bytes 5-28 the corresponding C-T-E integers (6i)
c     bytes 29-30 the latitude of the top edge, in degrees N (integer part)
c     bytes 31-32 the latitude of the top edge, in degrees N
c                 (fract part, in thousandths)
c     bytes 33-34 the latitude of the bottom edge, in degrees N (integer part)
c     bytes 35-36 the latitude of the bottom edge, in degrees N
c                 (fract part, in thousandths)
c     bytes 37-38 the longitude of the E edge, in degrees E (integer part)
c     bytes 39-40 the longitude of the E edge, in degrees E
c                 (fract part, in thousandths)
c     bytes 41-42 the longitude of the W edge, in degrees E (integer part)
c     bytes 43-44 the longitude of the W edge, in degrees E
c                 (fract part, in thousandths)
c     bytes 45-47 the number of NS cells
c     bytes 48-49 the number of EW cells
c     bytes 50-99 the name of the model (alpha)
c
c     bytes 100--> the real values of the tide in each cell, running EW
c           and then NS (ie ordered as a matrix), followed by the
c           imaginary values. The units are mm
c
c
      character*80 mdfile
      character*50 mdnam
      character*4 dsym
      integer*2 ir1,im1
      dimension ir1(1),im1(1)
      common/modpar/mdfile,dsym,icte(6),mdnam
      common/modlim/tlat,blat,wlong,elong,latc,longc
      llu =  1
      open(unit=llu,file=mdfile,status='old',access='sequential',
     $    form="unformatted")
      read(llu) dsym
      read(llu) (icte(i),i=1,6)
      read(llu) latd,latf
      tlat = latd + latf/1000.
      read(llu) latd,latf
      blat = latd + latf/1000.
      read(llu) latd,latf
      elong = latd + latf/1000.
      read(llu) latd,latf
      wlong = latd + latf/1000.
      read(llu) latc,longc
      read(llu) mdnam
      read(llu) (ir1(i),i=1,latc*longc)
      read(llu) (im1(i),i=1,latc*longc)
      close(llu)
      return
      end

      subroutine sph(grlat,elong,ht)  
c   for a point at geographical north latitude grlat, east longitude elong      
c   (in degrees), and height ht (in meters), finds geocentric position   
c   and local g using formulae for a spheroid
c  
      common/obs/cthet,sthet,clong,slong,dvert,radn,g      
      data gn,ae,f,rm,dr/9.798277692,6378137.,.00335281,.00344978,
     $ .01745329252/    
      clong = cos(elong*dr)    
      slong = sin(elong*dr)    
c   latitude difference 
      dvert = f*(1.+.5*f)*sin(2.*grlat*dr) - .5*f*f*sin(4.*grlat*dr)     
      gcclat = (3.1415926535898/2.) - (grlat*dr - dvert)   
      cthet = cos(gcclat)      
      sthet = sin(gcclat)      
c   geocentric radius   
      radn = 1. - f*(cthet**2)*(1. + 1.5*f*(sthet**2))     
c   formulae for g are from jeffreys, 4.022 and 4.023      
      g = gn*(1. + f - 1.5*rm + f*(f-(27./14.)*rm) + (2.5*rm - f -f*(f-  
     $ (39./14.)*rm))*(cthet**2) - (f/2.)*(7.*f-15.*rm)*((cthet*sthet)   
     $**2))      
c   free air correction 
      g = g - g*(2.*ht*(1.+f+rm - 2.*f*(cthet**2))/ae)     
      return     
      end 

      subroutine ocmodl(rlato,rlong,fingrd,amp)
c
c  For given latitude and east longitude (in degrees and ge 0) returns
c  the complex amplitude of the tide (in meters, with greenwich phase).
c  this amplitude is of course zero on land.
c    If fingrd is "F", then the land-sea grid used is a detailed one;
c  otherwise it is the one used by the ocean model.
c
c    On the first call, this calls a separate routine (ocstart) which
c  gets auxiliary information (passed to other routines in common) and
c  returns the two arrays of real and imaginary amplitude.  Later calls
c  simply go to the appropriate point of the arrays. 
c
c    The first call also reads in, if requested, information about
c  polygonal areas (up to 10) within which the point either must or
c  must not fall.
c
c   $$$$calls ocstart,lndsea,mrsdn,ibit
c
      save ir1,im1,newf
      character*1 fingrd
      integer*2 ir1,im1
      complex amp,bg,cz,bgs
      integer*4 ind
      logical*1 ispoly,use
      character*80 polyf
c
c  dimensioning of arrays below must be large enough to handle the largest
c  models
c
      dimension ir1(260000),im1(260000)
      dimension bg(4)
      common /modlim/tlat,blat,wlong,elong,latc,longc
c  common block holds polygon file information
      common/polinf/np,npoly(10),xpoly(100,10),ypoly(100,10),
     1            polyf,use(10),ispoly
      common/coninf/dist,close,clat,clong,numnf,clnf,farnf
      data cz/(0.,0.)/,newf/1/
      if(newf.eq.1) then
c new files - load arrays (polygon information loaded into common)
         newf = 0
	 call ocstart(ir1,im1)
	 if(ispoly) call plstart
      endif
      call celfnd(rlong,rlato,x,y,i,j,ind)
c ind is cell number; x and y are positions within cell, relative to center,
c in E and N, in fractions of a cell dimension
      if(ind.gt.latc*longc.or.ind.le.0) then
         amp = cz
         return
      endif
      if(ispoly) then
c if cell is inside a polygon we don't want, or outside one we do, reject
c it without going further
	 call chkgon(rlong,rlato,iok)
	 if(iok.eq.0) then
            amp = cz
            return
         endif
      endif
      if(fingrd.ne.'F') then
c
c  large distance - return the model value (0 if on land)
c
         amp = .001*cmplx(float(ir1(ind)),float(im1(ind)))
         return
      else
c
c  close distance - use the
c  5-minute map file to decide if there is land or not. If not, bilinearly
c  interpolate from the ocean model, filling out empty cells to make this
c  possible (though if all the cells needed are zero, return this).
c
         call lndsea(rlato,rlong,lnd)
         if(lnd.eq.1) then
c  detailed grid says land - return 0
            amp = cz
            return
         endif
         if(lnd.eq.2) then
c  detailed map says ocean -load an interpolating array of four elements
c  with values from adjacent cells, depending on which quadrant of the cell
c  we are in. In the process note how many nonzero values we have; save one
            ix = 1
	    if(x.le.0) ix = -ix
            iy = -longc
	    if(y.le.0) iy = -iy
	    x=abs(x)
	    y=abs(y)
	    nnz=0
	    do 5 i=1,4
	    if(i.eq.1) ibind=ind
	    if(i.eq.2) ibind=ind+ix
	    if(i.eq.3) ibind=ind+ix+iy
	    if(i.eq.4) ibind=ind+iy
            if(ibind.le.0.or.ibind.gt.latc*longc)
     1       bg(i) = cz
            if(ibind.gt.0.and.ibind.le.latc*longc)
     1       bg(i) = 0.001*cmplx(float(ir1(ibind)),float(im1(ibind)))
	    if(bg(i).ne.cz) nnz = nnz+1
	    if(bg(i).ne.cz) bgs = bg(i)
 5          continue
c
c  now we have a grid for interpolation: the values are arranged as
c
c           4      3
c           1      2
c
c  where (1) is the value we are closest to.
c
c  we now fill out the zero values (if any) from the nonzero ones
c  (Except that if there are 0 or 4 nonzero values we needn't bother)
            if(nnz.eq.1) then
c  the one saved value is the nonzero one: fill out the whole array with this
               do 7 i=1,4
 7             bg(i) = bgs
	    endif
            if(nnz.eq.2) then
c  two values: either in a row, a column, or diagonal:
               if(bg(1).ne.cz.and.bg(2).ne.cz) then
                  bg(4) = bg(1)
                  bg(3) = bg(2)
               endif
               if(bg(2).ne.cz.and.bg(3).ne.cz) then
                  bg(4) = bg(3)
                  bg(1) = bg(2)
               endif
               if(bg(3).ne.cz.and.bg(4).ne.cz) then
                  bg(1) = bg(4)
                  bg(2) = bg(3)
               endif
               if(bg(4).ne.cz.and.bg(1).ne.cz) then
                  bg(3) = bg(4)
                  bg(2) = bg(1)
               endif
c     diagonals
               if(bg(4).ne.cz.and.bg(2).ne.cz) then
                  bg(3) = 0.5*(bg(4)+bg(2))
                  bg(1) = bg(3)
               endif
               if(bg(1).ne.cz.and.bg(3).ne.cz) then
                  bg(4) = 0.5*(bg(1)+bg(3))
                  bg(2) = bg(3)
               endif
	    endif
	    if(nnz.eq.3) then
c one missing value
	       if(bg(1).eq.cz) bg(1) = bg(4)+bg(2)-bg(3)
	       if(bg(2).eq.cz) bg(2) = bg(1)+bg(3)-bg(4)
	       if(bg(3).eq.cz) bg(3) = bg(4)+bg(2)-bg(1)
	       if(bg(4).eq.cz) bg(4) = bg(1)+bg(3)-bg(2)
	    endif
c  bilinear interpolation
	    amp = bg(1)*(1-x)*(1-y) + bg(2)*x*(1-y) +
     1            bg(4)*(1-x)*y     + bg(3)*x*y
c  if all the values are zero, we will return zero - but we pass some
c  information about this through common block coninf; the first time this
c  happens, set clnf and farnf to the current distance from the station,
c  and afterwards only farnf (since we always increase the distance).
	    if(nnz.eq.0) then
	       if(numnf.eq.0) then
		  clnf = dist
		  farnf = dist
	       else
		  farnf = dist
	       endif
	       numnf=numnf+1
	    endif
	    return
         endif
      endif
      end

c     program erthtd
c
c     BOMM subroutine written by Jon Berger  November 1969
c     astronomy revised by Judah Levine (after J C Harrison) Sept 1973
c     updated by Karen Young  March 1977, for PDP 11
c     emended by Duncan Agnew June 1978 to speed execution
c     solar astronomy redone and rigid-earth potential added by Duncan
c     Agnew June 1979
c     tide generating part put in separate subroutine and computation
c     of Munk-Cartwright coefficients added by Duncan Agnew Feb 1981,
c     July 1982
c
c      This version rewritten for export, using F77 calls for I/O,
c     by Duncan Agnew Mar 1987
c
c     tides are calculated from harmonics 2 through 3 for
c     the lunar terms, 2 for the solar terms.
c     love numbers h(n), k(n), and l(n) are set by data statements.
c
c     gravity tide is in microgals, plus for up acceleration
c     rigid-earth potential is in meters (v/g), plus for up
c     tilt tide is in nanoradians (nr)......  1 nr = 2.063e-4 arcsec
c     strain tide is in parts in e9, plus for extension
c
c     azimuths for strain and tilt are reckoned
c     positive clockwise from north (east from north)
c
      character*1 ioptn
      character*40 filnam
      double precision tt,ts,te,d,zhr,yhr,t
      real iyr,jyr,iday,jday,k,l,lamda
      dimension serout(60,7),ntw(3),tilt(2),strain(3),a(14),iget(7),
     1 ispc(4),filnam(7)
      common/bpos/dsz,dcs,dsl,dcl,ssz,scz,ssl,scl,dpar,sdist
      common/love/h(3),k(3),l(3)
      common/azimut/azt(3,2),azs(3,3)
      common/tdiff/etmut
      common/sunny/moon
      data h/.6114,.2891,.175/,k/.304,.09421,.043/,
     1 l/.0832,.0145,.0103/
      data irl/0/,iflag/0/,ntotl/0/,iget/7*0/,ispc/4*0/,ntw/3*0/,
     1 moon/0/
c
c   data statements for input and output unit numbers (on terminal I/O)
c    and blocklength (in reals) of the data arrays
c
      data inun/5/,ioun/6/,nptpb/60/
      write(ioun,701)
701   format(' Start time- - -  (year,day,hour)   ',t45,$)
      read(inun,*) iyr,iday,zhr
      iyr=iyr-1900
      write(ioun,702)
702   format(' End time- - -  (year,day,hour)  ',t45,$)
      read(inun,*) jyr,jday,yhr
      jyr=jyr-1900
      write(ioun,703)
703   format(' Time interval (hours)-      ',$)
      read(inun,*) d
c   find times in hours from 0 hr, 1 jan 1900
      ts=zhr+24.d0*(iday-1)+8760.d0*iyr+24.d0*int((iyr-1)/4)
      te=yhr+24.d0*(jday-1)+8760.d0*jyr+24.d0*int((jyr-1)/4)
      terms=(te-ts)/d + 1.
      nrec=1
 5    write(ioun,7035)
 7035 format(' Type t for theoretical tides, m for Munk-'
     1 ,'Cartwright coefficients ',$)
      read(inun,*) ioptn
      if(ioptn.ne.'m'.and.ioptn.ne.'t') go to 5
      if(ioptn.eq.'t') go to 69
      nrec = 1
 6    write(ioun,7036)
 7036 format(' Type 2 for order 2, 3 for 3, 4 for both ',$)
      read(inun,*) iord
      if(iord.lt.2.or.iord.gt.4) go to 6 
      nspc = min0(iord+1,4)
      write(ioun,7037)
 7037 format(' Type 1 to get long-period tides ',$)
      read(inun,*) ispc(1)
      write(ioun,7038)
 7038 format(' Type 1 to get diurnal tides ',$)
      read(inun,*) ispc(2)
      write(ioun,7039)
 7039 format(' Type 1 to get semidiurnal tides ',$)
      read(inun,*) ispc(3)
      if(nspc.eq.4) write(ioun,7040)
 7040 format(' Type 1 to get terdiurnal tides ',$)
      if(nspc.eq.4) read(inun,*) ispc(4)
      do 20 i=1,nspc
      if(ispc(i).le.0) go to 20
      if((iord.eq.2.or.iord.eq.4).and.i.le.3) iget(i)=1
      if(iord.ge.3) iget(i+3) = 1
 20   continue
      ntotl = 0
      do 21 i=1,7
 21   if(iget(i).eq.1) ntotl=ntotl+1
      go to 741
 69   write(ioun,704)
704   format(' North latitude-      ',$)
      read(inun,*) theta
      write(ioun,705)
705   format(' East longitude-      ',$)
      read(inun,*) lamda
      write(ioun,706)
 706  format(' Number of gravity (0 to 1), tilt (0-2), and'
     $,' strain (0-3) tides wanted')
      do 710 i=1,3
      read(inun,*) ntw(i)
  710 ntotl = ntotl + iabs(ntw(i))
      if(ntw(2).eq.0) go to 732
      write(ioun,707)
 707  format(' Tiltmeter azimuth(s) - positive clockwise from'
     $ ,' north ',$)
      do 731 i = 1,ntw(2)
      read(inun,*) azt(1,i)
      azt(2,i) = cos(azt(1,i)/57.2958)
 731  azt(3,i) = sin(azt(1,i)/57.2958)
 732  if(ntw(3).eq.0) go to 741
      write(ioun,708)
 708  format(' Strainmeter azimuth(s) - positive clockwise from'
     $ ,' north ',$)
      do 733 i = 1,ntw(3)
      read(inun,*) azs(1,i)
      azs(2,i) = cos(azs(1,i)/57.2958)
 733  azs(3,i) = sin(azs(1,i)/57.2958)
 741  write(ioun,709) ntotl
 709  format(' Enter output filenames (total of ',i1,')')
c
c  open direct-access files, nptpb real*4's per record
c
      do 7099 i=1,ntotl
      read(inun,7098) filnam(i)
 7098 format(a40)
      iunit = i
c skip units 5 and 6
      if(i.ge.5) iunit = i+2
      open(unit=iunit,file=filnam(i))
CC     $ form='unformatted',recl=4*nptpb)
 7099 continue
      write(ioun,903) ts,te,d
 903  format(' Time runs from',f12.4,' to',f12.4,
     $' with interval',f12.4)
c
c     done asking questions - begin execution
c
      i = 1
      tt = ts
      call sph(theta,lamda,0.)
      etmut = 41.184 + iyr - 70
 10   if(tt.gt.te) go to 749
      t = (tt+12.d0 + (etmut/3600.d0))/876600.d0
c   t is ephemeris time in julian centuries from 12 hr 0 jan 1900
      call ephem(t)
      if(ioptn.eq.'m') go to 80
c
c     calculate normailzed total tides
c
      call elastd(grav,tilt,strain,ntw)
      if(ntw(1).eq.0) go to 71
c   gravity
      serout(i,1) = 1.e8*grav
      if(ntw(1).eq.-1) serout(i,1) = grav
 71   if(ntw(2).eq.0) go to 73
c   tilt
      do 72 kk = 1,ntw(2)
      idd = iabs(ntw(1)) + kk
 72   serout(i,idd) = 1.e9*tilt(kk)
 73   if(ntw(3).eq.0) go to 3
c   strain
      do 74 kk = 1,ntw(3)
      idd = iabs(ntw(1)) + ntw(2) + kk
 74   serout(i,idd) = 1.e9*strain(kk)
      go to 3
 80   call mcco(a,a(8))
      idd = 0
      do 81 kk =1,7
      if(iget(kk).eq.0) go to 81
      idd = idd + 1
      serout(i,idd) = a(kk)
      serout(i+1,idd) = a(7+kk)
 81   continue
c  double increment for mc coefficients
      i = i + 1
 3    i = i + 1
      tt = tt + d
      if(i.eq.nptpb+1) go to 750
      go to 10
 749  iflag = 1
      if(i.eq.1) go to 770
c
c      write data out
c
750   do 751 kk = 1,ntotl
      npts = nptpb
      if(iflag.eq.1) npts = i - 1
      iunit = kk
      if(kk.ge.5) iunit = kk+2
CCC      write(iunit,rec=irl) (serout(jj,kk),jj=1,nptpb)
      write(iunit,7501) (serout(jj,kk),jj=1,npts)
 7501 format(5g13.5)
 751  continue
      i = 1
      irl = irl + npts
      if(iflag.eq.0) go to 10
770   write(ioun,771) irl
771   format(//' each output series is ',i8,' terms long'/)
      stop
      end
      subroutine sph(grlat,elong,ht)  
c   for a point at geographical north latitude grlat, east longitude elong      
c   (in degrees), and height ht (in meters), finds geocentric position   
c   and local g using formulae for a spheroid
c  
      common/obs/cthet,sthet,clong,slong,dvert,radn,g      
      data gn,ae,f,rm,dr/9.798277692,6378140.,.00335281,.00344978,
     $ .01745329252/    
      clong = cos(elong*dr)    
      slong = sin(elong*dr)    
c   latitude difference 
      dvert = f*(1.+.5*f)*sin(2.*grlat*dr) - .5*f*f*sin(4.*grlat*dr)     
      gcclat = (3.1415926535898/2.) - (grlat*dr - dvert)   
      cthet = cos(gcclat)      
      sthet = sin(gcclat)      
c   geocentric radius   
      radn = 1. - f*(cthet**2)*(1. + 1.5*f*(sthet**2))     
c   formulae for g are from jeffreys, 4.022 and 4.023      
      g = gn*(1. + f - 1.5*rm + f*(f-(27./14.)*rm) + (2.5*rm - f -f*(f-  
     $ (39./14.)*rm))*(cthet**2) - (f/2.)*(7.*f-15.*rm)*((cthet*sthet)   
     $**2))      
c   free air correction 
      g = g - g*(2.*ht*(1.+f+rm - 2.*f*(cthet**2))/ae)     
      return     
      end 
      subroutine ephem(t)
      double precision t
c   t is ephemeris time in julian centuries from 12 hr 0 jan 1900
c  (in ordinary civil reckoning this is greenwich noon on 31 december
c  1899). if the difference between ephemeris and unversal time is
c  not put in (see common tdiff below), t should be in universal time
c  which is (nearly) the time ordinarily kept by clocks.
c   computes positions of the sun and moon at time t, returning results
c  in common block bpos. the solar ephemeris uses the mean sun.
c    Derived from J. Levine's revision (after J. C. Harrison)
c  of an earthtide program by J. Berger and W. E. farrell, with small
c  alterations by D. C. Agnew, partly after M. Wimbush. present
c  subroutine version by d. c. agnew.
      double precision ts,hr,pi20,t2,ll,xxx,hs,ps,es,psig,chmp,shmp,
     $ ls,sz,cz,psis,hm,pm,nm,bl,bls,bf,bd,tlatm,tlongm,plx,sinmla,
     $ cosmla,sinmln,cosmln,at1,at2,ram,w,sinw,cosw,sls
c  common block bpos contains, in order:
c    sine and cosine of colatitude of sublunar point
c    sine and cosine of east longitude of sublunar point
c    sine and cosine of colatitude of subsolar point
c    sine and cosine of east longitude of subsolar point
c    the lunar sine parallax in arc seconds
c    the solar distance in astronomical units
      common/bpos/dsz,dcz,dsl,dcl,ssz,scz,ssl,scl,dpar,sdist
c
c  common block containing the difference ephemeris minus
c  universal time, in seconds. if this is not known it should
c  be set to zero, and the argument to the program should be
c  universal rather than ephemeris time.
c
      common/tdiff/etmutc
c  common block containing the instruction on which ephemeris to compute
c  moon =   0  - both sun and moon
c           1  - moon only
c           2  - sun only
      common/sunny/moon
      fcos(xxx) = cos(sngl(xxx))
      fsin(xxx) = sin(sngl(xxx))
      data pi20/62.8318530717958d0/
c   compute universal time in hours
      ts = 876600.d0*t -12.d0 - (etmutc/3600.d0)
      hr = dmod(ts,24.d0)
c   compute obliquity of the ecliptic
      w = .409319747d0 - .0002271107d0*t
      cosw = dcos(w)
      sinw = dsin(w)
      t2 = t*t
      if(moon.eq.1) go to 7
c
c     compute solar constants for given t
c
      hs = 4.881627982482d0 + 628.3319508731d0*t + 0.523598775578d-5*t2
      hs = dmod(dmod(hs,pi20)+pi20,pi20)
      ps = 4.908229466993d0+ 0.03000526416690d0*t + 0.790246300201d-5*t2
      es = 0.01675104d0 - 0.00004180d0*t - 0.000000126d0*t2
      psig = 0.2617993877971d0*(hr-12.) + hs
      chmp = dcos(hs-ps)
      shmp = dsin(hs-ps)
      ls = hs + shmp*es*(2.+2.5*es*chmp)
      sls = dsin(ls)
      cz = sinw*sls
      sz = dsqrt(1.-cz**2)
      psis = datan2(cosw*sls,dcos(ls))
      rbarr = 1. + es*(chmp + es*(chmp-shmp)*(chmp+shmp))
      ll = psis - psig
      scz = cz
      ssz = sz
      ssl = sin(ll)
      scl = cos(ll)
      sdist = 1./rbarr
c
c     compute lunar constants for given t
c
 7    if(moon.eq.2) return
      hm=4.7199666d0+8399.7091449d0*t-.0000198d0*t2
      pm=5.83515154d0+71.01804120839d0*t-.180205d-3*t2
      nm=4.523601515d0-33.75714624d0*t+.3626406335d-4*t2
c.......  bl bls bf bd are the fundamental arguments of browns theory
      bl=hm-pm
      bls=hs-ps
      bf=hm-nm
      bd=hm-hs
c.........lunar lat long and parallax from brown.  latter two from
c......improved lunar ephemeris, latitude from ras paper of 1908...
      tlongm=hm+.10976*fsin(bl)-.02224*fsin(bl-2.*bd)+0.01149*fsin(2.*bd
     1)+0.00373*fsin(2.*bl)-.00324*fsin(bls)-.00200*fsin(2.*bf)-0.00103*
     2fsin(2.*bl-2.*bd)-.00100*fsin(bl+bls-2.*bd)+0.00093*fsin(bl+2.*bd)
     3-.00080*fsin(bls-2.*bd)+.00072*fsin(bl-bls)-.00061*fsin(bd)-.00053
     4*fsin(bl+bls)
      tlatm=.08950*fsin(bf)+.00490*fsin(bl+bf)-.00485*fsin(bf-bl)-.00303
     1 *fsin(bf-2.*bd)+.00097*fsin(2.*bd+bf-bl)-.00081*fsin(bl+bf-2.*bd)
     2+.00057*fsin(bf+2.*bd)
      plx=(3422.45+186.54*fcos(bl)+34.31*fcos(bl-2.*bd)+28.23*fcos(2.*bd
     1)+10.17*fcos(2.*bl)+3.09*fcos(bl+2.*bd)+1.92*fcos(bls-2.*bd)+1.44*
     2fcos(bl+bls-2.*bd)+1.15*fcos(bl-bls)-0.98*fcos(bd)-0.95*fcos(bl+
     3bls)-0.71*fcos(bl-2.*bf)+0.62*fcos(3.*bl)+0.60*fcos(bl-4.*bd))
      sinmla=dsin(tlatm)
      cosmla=dcos(tlatm)
      sinmln=dsin(tlongm)
      cosmln=dcos(tlongm)
c...convert from celestial lat and long according to explan suppl of
c......na and le page 26
      cz=cosmla*sinmln*sinw+sinmla*cosw
      sz=dsqrt(1.-cz**2)
      at1=cosmla*sinmln*cosw-sinmla*sinw
      at2=cosmla*cosmln
      ram=datan2(at1,at2)
      ll=ram-psig
      dcz = cz
      dsz = sz
      dsl = sin(ll)
      dcl = cos(ll)
      dpar = plx
      return
      end
      subroutine mcco(a,b)     
c   computes a and b tidal potential coefficients as in Munk and Cartwright     
c    1966, in meters for a sphere with the earths equatorial radius.     
c   coefficients are returned in a and b, in order of increasing l (l = 2 or 3) 
c    and for each l in order of increasing m.  b(1) and b(4) are zero.   
c  
      dimension a(7),b(7),rk(4),c(7),cl(4),sl(4),pa(2),rnorm(7)   
c   common with solar and lunar positions    
      common/bpos/coor(8),par,sdist   
c   tidal coefficients are from 1976 iau constants  
      data rk/.3583728,.0059463,.16457875,.00000702/,cl(1)/1./,sl(1)/0./ 
      data ifl/0/,fpi/12.566370614/,c(1)/1./ 
c   on first call compute normalizing coefficiants  
      if(ifl.ne.0) go to 3     
      ifl = 1    
      do 1 i = 2,7      
 1    c(i) = (i-1.)*c(i-1)     
      do 2 l = 2,3      
      mu = l + 1 
      do 2 m = 1,mu     
      i = 3*(l/3) + m   
      t = 1. + (m+1)/3  
 2    rnorm(i) =((-1)**(m+1))*t*sqrt((fpi*c(l-m+2))/((2.*l+1)*c(l+m)))   
c   find normalized parallax   
 3    pa(1) = par/3422.448     
      pa(2) = 1./sdist  
      do 4 i = 1,7      
      a(i) = 0.  
 4    b(i) = 0.  
      do 6 n = 1,2      
c   n = 1 for lunar part, 2 for solar 
      do 5 i = 1,3      
      cl(i+1) = coor(4*n)*cl(i) - coor(4*n-1)*sl(i) 
 5    sl(i+1) = coor(4*n)*sl(i) + coor(4*n-1)*cl(i) 
      cz = coor(4*n-2)  
      sz = coor(4*n-3)  
      c(1) = (3.*cz*cz - 1.)/2.
      c(2) = 3.*cz*sz   
      c(3) = 3.*sz*sz   
      c(4) = (5./3.)*cz*(c(1) - .4)   
      c(5) = 1.5*sz*(5.*cz*cz - 1.)   
      c(6) = 5.*cz*c(3) 
      c(7) = 5.*sz*c(3) 
      do 6 l = 2,3      
      mu = l + 1 
      do 6 m = 1,mu     
      k = 3*(l/3) + m   
      c(k) = rnorm(k)*rk(2*n+l-3)*(pa(n)**(l+1))*c(k)      
      a(k) = a(k) + c(k)*cl(m) 
 6    b(k) = b(k) + c(k)*sl(m) 
      return     
      end 
      subroutine elastd(grav,tilt,strain,ntw)
      real k,l
      dimension tilt(2),strain(3),ntw(3),amrat(2),rbor(2),pa(2),p(3),
     1 pp(3),ppp(3),e(3),rkr(3),tltcor(2),del(3),dim(3)
c  computes the earth tides on an elastic earth, given the solar and lunar
c  positions and the place of observation.  degree 2 is used for the solar
c  tides, 2 through 4 for the lunar tides. the results are returned in
c  grav, tilt, and strain. ntw(1) gives the number of gravity tides
c  ntw(2) the number of tilt tides, ntw(3) the number of strain tides.
c  as the dimensioning shows, at most one gravity tide, two tilts, and
c  three strains may be computed.  if ntw(1) = -1, the program will
c  put the equilibrium potential height for a rigid spherical earth in
c  grav.  the units are m/s**2, radians, extension, and meters.
c  the sign convention is positive for upward potential
c  height, a decrease in g, a tilt in the azimuth given, and
c  extensional strain.
c  that part of the tidal signal which comes from the permanent
c  deformation is subtracted out, using the coefficient of .31455 m
c  found by Cartwright and Edden for the dc tide.
c
c   based (very closely) on J. Berger earth tide program.
c   converted to subroutine by D. Agnew Nov 1979.
c   computation of the potential and subtraction of dc tides added
c   by D. Agnew Jan 1980.
c
c  common block with observatory information
      common/obs/cth,sth,clg,slg,dif,radn,gl
c  common block with love numbers
      common/love/h(3),k(3),l(3)
c  common block with strainmeter and tiltmeter azimuths
      common/azimut/azt(3,2),azs(3,3)
c  common block with lunar and solar colat and long, lunar sine parallax,
c  and solar distance
      common/bpos/coor(8),par,sdist
c  data for mean parallaxes, a times m over m(earth), equatorial radius.
      data rbor/1.6592496e-2,4.2635233e-5/,amrat/78451.25,
     1  2.1235762e12/,a/6.37814e6/
      data g1/9.79828/,g2/9.82022/,ppp(1)/3./,iflag/0/
c  on first call compute factors for gravity and tilt, and dc tides
c  at the given latitude.
      if(iflag.eq.1) go to 3
      iflag=1
      do 1 i = 1,3
      del(i) = 1. + (2./(i+1.))*h(i) - ((i+2.)/(i+1.))*k(i)
 1    dim(i) = 1. + k(i) - h(i)
c  dc gravity tide is also known as the Honkasalo correction
c  **note that the love numbers for an elastic earth are used
c    in computing the dc tide as well
      gdc = -3.0481e-7*(3*cth**2 - 1.)*del(1)*radn
      tnsdc = -9.1445e-7*cth*sth*dim(1)*radn/gl
      etdc = -1.555e-8*(h(1)*(3.*cth**2-1.) - 6.*l(1)*(2.*cth**2 -1.))
      eldc = -1.555e-8*(h(1)*(3.*cth**2-1.) - 6.*l(1)*cth**2)
      potdc = .0992064*(1.-3*cth**2)
      re = 1./(radn*a)
c  zero out arrays
 3    do 4 i = 1,2
      tilt(i) = 0.
      e(i) = 0.
 4    tltcor(i) = 0.
      e(3) = 0.
      grav = 0.
      gnth = 0.
c  compute normalized parallax
      pa(1) = par/3422.45
      pa(2) = 1./sdist
c  in outer loop, ii = 1 for moon, 2 for sun
      do 40 ii = 1,2
      id = 3
      if(ii.eq.2) id = 1
      ir = 4*(ii-1)
c  find cosine of zenith angle, potential constants, legendre polynomials
c  and their derivatives, and derivatives of the cosine of the zenith
c  angle.
      cll = clg*coor(ir+4) + slg*coor(ir+3)
      sll = slg*coor(ir+4) - clg*coor(ir+3)
      cz = coor(ir+2)
      sz = coor(ir+1)
      cu = cth*cz + sth*sz*cll
      xi = rbor(ii)*pa(ii)*radn
      cc = amrat(ii)*rbor(ii)*pa(ii)
      rkr(1) = cc*xi*xi
      rkr(2) = rkr(1)*xi
      rkr(3) = rkr(2)*xi
      p(1) = 0.5*(3*cu*cu - 1.)
      pp(1)=3*cu
      if(ii.eq.2) go to 5
      p(2) = .5*cu*(5.*cu*cu - 3.)
      p(3) = .25*(7.*cu*p(2) - 3.*p(1))
      pp(2) = 1.5*(5.*cu*cu - 1.)
      pp(3) = .25*(7.*p(2) + cu*pp(2)) - 3.*pp(1)
      ppp(2) = 15.*cu
      ppp(3) = 7.5*(7.*cu*cu - 1.)
 5    cut = -sth*cz + cth*sz*cll
      cutt = -cu
      cul = -sth*sz*sll
      cull = -sth*sz*cll
      cutl = -cth*sz*sll
      if(ntw(1).eq.0) go to 15
      do 10 j = 1,id
      if(ntw(1).eq.-1) grav = grav + rkr(j)*p(j)
 10   if(ntw(1).eq.1) grav = grav + del(j)*(j+1)*rkr(j)*p(j)*g1*re
      gnth = gnth - dim(1)*rkr(1)*pp(1)*g1*cut*re
 15   if(ntw(2).eq.0) go to 30
      do 25 kk = 1,ntw(2)
      do 20 j=1,id
 20   tilt(kk)=tilt(kk)-(dim(j)*rkr(j)*pp(j)*re)*(cut*azt(2,kk)
     $ - cul*azt(3,kk)/sth)
 25   tltcor(kk) = tltcor(kk) + del(1)*2.*rkr(1)*p(1)*re
 30   if(ntw(3).eq.0) go to 40
      do 35 j = 1,id
      e(1) = e(1) + rkr(j)*(l(j)*(pp(j)*cut*cth/sth + (ppp(j)*cul*cul
     1 + pp(j)*cull)/(sth*sth)) + h(j)*p(j))
      e(2) = e(2) + rkr(j)*(l(j)*(ppp(j)*cut*cut + pp(j)*cutt) +
     1  h(j)*p(j))
      e(3) = e(3) + 2*(rkr(j)*l(j)*(ppp(j)*cul*cut + pp(j)*cutl -
     1 cth*pp(j)*cul/sth))/sth
  35  continue
  40  continue
c  do ellipticity corrections, convert strains to strainmeter
c  azimuths, and remove dc terms.
      if(ntw(1).eq.1) grav = grav + gnth*dif - gdc
      if(ntw(1).eq.-1) grav = grav - potdc
      do 45 i =1,ntw(2)
 45   tilt(i) = tilt(i)*(g1/gl) -tltcor(i)*dif*azt(2,i) -tnsdc*azt(2,i)
      do 50 i = 1,ntw(3)
 50   strain(i) = (e(1)*azs(3,i)**2 - e(3)*azs(3,i)*azs(2,i)
     $+e(2)*azs(2,i)**2)*re*(g1/g2) -etdc*azs(2,i)**2 -eldc*azs(3,i)**2
      return
      end

      function inpoly(x,y,xv,yv,nv)
c
c   Returns 1 if point at (x,y) is inside polygon whose nv vertices
c   are at xv(1),yv(1);...,xv(nv),yv(nv)
c   Returns 0 if point is outside
c   Returns 2 if point is on edge or vertex
c
c     Rewritten by D. Agnew from the version by Godkin and Pulli,
c     in BSSA, Vol 74, pp 1847-1848 (1984)
c
c    $$$$$calls ncross (in this file)
c
      dimension xv(nv),yv(nv)
      inpoly = 0
      do 5 i=1,nv-1
      isc = ncross(xv(i)-x,yv(i)-y,xv(i+1)-x,yv(i+1)-y)
      if(isc.eq.4) then
c  on edge - know the answer
         inpoly = 2
         return
      endif
      inpoly = inpoly + isc
 5    continue
c  check final segment
      isc = ncross(xv(nv)-x,yv(nv)-y,xv(1)-x,yv(1)-y)
      if(isc.eq.4) then
         inpoly = 2
         return
      endif
      inpoly = inpoly + isc
      inpoly = inpoly/2
c  convert to all positive (a departure from the original)
      inpoly = iabs(inpoly)
      return
      end
      function ncross(x1,y1,x2,y2)
c
c   finds whether the segment from point 1 to point 2 crosses
c   the negative x-axis or goes through the origin (this is
c   the signed crossing number)
c     return value       nature of crossing
c         4               segment goes through the origin
c         2               segment crosses from below
c         1               segment ends on -x axis from below
c                          or starts on it and goes up
c         0               no crossing
c        -1               segment ends on -x axis from above
c                          or starts on it and goes down
c        -2               segment crosses from above
c
      if(y1*y2.gt.0) then
c all above (or below) axis
         ncross = 0
         return
      endif
      c12 = x1*y2
      c21 = x2*y1
      if(c12.eq.c21.and.x1*x2.le.0.) then
c through origin
         ncross = 4
         return
      endif
      if((y1.eq.0.and.x1.gt.0).or.(y2.eq.0.and.x2.gt.0)
     1 .or.((y1.lt.0).and.(c12.gt.c21)).or.((y1.gt.0).and.(c12.lt.c21))
     2 .or.(y1.eq.0.and.y2.eq.0.and.x1.lt.0.and.x2.lt.0)) then
c touches +x axis; crosses +x axis; lies entirely on -x axis
         ncross = 0
         return
      endif
      if(y1.ne.0.and.y2.ne.0) then
c  cross axis
         if(y1.lt.0) ncross = 2
         if(y1.gt.0) ncross = -2
         return
      endif
c one end touches -x axis - goes which way?
      if(y1.eq.0) then
         if(y2.lt.0) ncross = -1
         if(y2.gt.0) ncross = 1
      else
c y2=0 - ends on x-axis
         if(y1.lt.0) ncross = 1
         if(y1.gt.0) ncross = -1
      endif
      return
      end

      subroutine etharm(cta,n,m,pot,grav,disp,tlt,str)
c  For a Cartwright-Tayler constituent of amp cta, order n, species m,
c  returns the potential height, gravity, tilt (ns and ew) and strain
c  (ns, ew and shear) for a point whose position is specified in
c  common block obs (previously filled using subroutine sph).
c  Except for the potential, the amplitudes are given with sign adjusted
c  so the local potential would be positive.
c  Note that tlt(2) and str(3) are in quadrature to
c  the other two. tlt(1) is north; tlt(2) is east; str(1) is north;
c  str(2) is east; str(3) is se (theta-lambda). disp(1) is vertical,
c  disp(2) is north, disp(3) is east
c
c      calls ifact,p (both in this source file)
c
      dimension h(2),sk(2),sl(2),tlt(2),str(3),disp(3)
      common/obs/ct,st,clg,slg,dv,r,g
      data pi/3.14159265/,gm/9.7982776/,ae/6378140./
c  Love numbers (should be kept the same as in ertid for consistency).
      data h/.6114,.2891/,sk/.304,.09421/,sl/.0832,.0145/
c  ynm normalizing factor
      j = n-1
      rn = ((2*n+1)*ifact(n-m))/(4*pi*ifact(n+m))
      rn = sqrt(rn)
      if(mod(m,2).ne.0) rn = -rn
c potential height in m
      pot =  cta*(gm/g)*(r**n)*rn*p(n,m,ct)
      grav = cta*(gm/ae)*n*(r**(n-1))*rn*p(n,m,ct)
c gravity in microgal
      grav = 1.e8*grav*(1.+ (2./n)*h(j) - ((n+1.)/n)*sk(j))
      sfac = (gm/(g*ae*(st**2)))*(r**(n-1))*rn
c strain in nanostrain
      str(1) = 1.e9*cta*sfac*(
     1  (h(j)*(st**2) + sl(j)*((n*ct)**2-n))*p(n,m,ct)
     2            -2.*sl(j)*(n-1)*(n+m)*ct*p(n-1,m,ct)
     3               + sl(j)*(n+m)*(n+m-1)*p(n-2,m,ct))
      str(2) = 1.e9*cta*sfac*(
     1  (h(j)*(st**2) + sl(j)*(n*(ct**2)-m**2))*p(n,m,ct)
     2                        -sl(j)*(n+m)*ct*p(n-1,m,ct))
      str(3) = 1.e9*cta*sfac*m*sl(j)*(
     1  (n-1)*ct*p(n,m,ct) - (n+m)*p(n-1,m,ct))
c tilt in nanorad
      tlt(1) = -1.e9*(1.+sk(j)-h(j))*cta*st*sfac*(n*ct*p(n,m,ct)
     1                           - (n+m)*p(n-1,m,ct))
      tlt(2) =  1.e9*(1.+sk(j)-h(j))*cta*st*sfac*m*p(n,m,ct)
      a = r*ae
c displacement in mm
      disp(1) = 1.e3*h(j)*pot
      disp(2) = (a*sl(j)/(1.+sk(j)-h(j)))*(tlt(1)/1.e6)
      disp(3) = (a*sl(j)/(1.+sk(j)-h(j)))*(tlt(2)/1.e6)
      return
      end
      function p(n,m,c)
c  computes some low-order legendre polynomials
      s = sqrt(1.-c*c)
      if(n.lt.m) p = 0
      if(n.eq.0.and.m.eq.0) p = 1.
      if(n.eq.1.and.m.eq.0) p = c
      if(n.eq.1.and.m.eq.1) p = s
      if(n.eq.2.and.m.eq.0) p = .5*(3*c*c - 1.)
      if(n.eq.2.and.m.eq.1) p = 3.*s*c
      if(n.eq.2.and.m.eq.2) p = 3.*s*s
      if(n.eq.3.and.m.eq.0) p =  .5*c*(5.*c*c - 3.)
      if(n.eq.3.and.m.eq.1) p = 1.5*s*(5.*c*c - 1.)
      if(n.eq.3.and.m.eq.2) p = 15.*s*s*c
      if(n.eq.3.and.m.eq.3) p = 15.*(s**3)
      return
      end
      function ifact(n)
      ifact = 1
      if(n.le.1) return
      do 1 i=2,n
 1    ifact = i*ifact
      return
      end

c  Program harprp
c
c  reads from standard input, a load file (or set of them),
c  selects the numbers associated with a particular quantity,
c  and writes out a file of harmonic constants suitable for tidal
c  prediction by hartid.
c
c  The designators (on the command line) are
c    o - ocean-tide height
c    g - gravity
c    z - vertical displacement
c    d - horizontal displacement at azimuth nnn
c    l - extension at azimuth nnn
c    v - volume strain (for poisson's ratio 0.25)
c    s - shear strain at azimuth nnn
c    t - tilt at azimuth nnn
c  where nnn is also given on the command line
c
      character*80 stnam
      character*50 mdnam,dumm
      character*4 dsym
      character*1 modo,type
      complex cload1,cload2,scale,phasor,cz
      dimension cload1(9),cload2(9)
      common /modpar/mdfile,dsym,icte(6),mdnam
c the following pair of functions convert between complex stored as
c amp and phase and complex stored as real and imaginary
      phasor(scale) =
     1 cmplx(cabs(scale),57.2958*atan2(aimag(scale),real(scale)))
      data luo/6/,lui/5/
      data scale/(1.,0.)/azim/0./,ifrst/0/cz/(0.,0.)/
      data cload1/9*(0.,0.)/
      if(iargc().lt.1.or.iargc().gt.2) then
	 write(luo,100)
 100  format('Usage: harprp o | g | z | v',/,
     1  'or:  harprp d | l | | s | t  azimuth ')
	 stop
      endif
      call getarg(1,type)
      if(type.eq.'d'.or.type.eq.'l'.or.type.eq.'s'.or.type.eq.'t') then
         if(iargc().ne.2) then
	    write(luo,100)
	    stop
         endif
         call getarg(2,dumm)
         read(dumm,102) azim
 102     format(f10.0)
      endif
c
c now read load file, getting coordinates and other information from
c the first two lines (plus the last "L" line for the phase)
c
 3    read(lui,201,end=33) stnam, rlat, rlam, ht
 201  format(3x,a40,3x,f10.4,f10.4,f10.0)
      read(lui,203) dsym,(icte(j),j=1,6),mdnam
 203  format(2x,a4,5x,6i2,3x,a1,4x,a50)
 5    read(lui,204) dumm
 204  format(a50)
      if(dumm(1:1).eq.'L') modo = dumm(3:3)
      if(dumm(1:1).ne.'X') go to 5
c      gravity
      read(lui,205) cload1(1)
 205  format(10x,2f10.4)
      if(type.ne.'o') then
c      displacement
         read(lui,207) (cload1(i),i=2,4)
 207     format(10x,6f10.4)
c      tilt
         read(lui,209) (cload1(i),i=5,6)
 209     format(10x,4f10.4)
c      strain
         read(lui,207) (cload1(i),i=7,9)
      endif
      call argand(cload1,9)
c
c adjust to a new azimuth, rotated azim deg (clockwise in the command line,
c converted to counterclockwise below to match the usual formulae) from the
C EW-NS one that the loads are orignally in.
c
      if(azim.ne.0) then
	 caz = cos(-azim/57.2958)
	 saz = sin(-azim/57.2958)
	 cload2(1) = cload1(1)
	 cload2(4) = cload1(4)
c           horizontal displacements (2 EW 3 NS 4 vert)
	 cload2(2) = caz*cload1(2) + saz*cload1(3)
	 cload2(3) = -saz*cload1(2) + caz*cload1(3)
c           tilts (5 EW 6 NS)
	 cload2(5) = caz*cload1(5) + saz*cload1(6)
	 cload2(6) = -saz*cload1(5) + caz*cload1(6)
c           strains (originally, 7 is EW 8 NS 9 shear (EN) )
	 cload2(7) = caz*caz*cload1(7) + saz*saz*cload1(8)
     1       + 2*caz*saz*cload1(9)
	 cload2(8) = caz*caz*cload1(8) + saz*saz*cload1(7)
     1       - 2*caz*saz*cload1(9)
	 cload2(9) = cload1(9)*(caz*caz-saz*saz)
     1       - caz*saz*(cload1(7)-cload1(8))
	 do 13 i=1,9
 13      cload1(i) = cload2(i)
      endif
c     special conversion for volume strain (do not need EW
c     after here)
      cload1(7) = 0.6667*(cload1(7) + cload1(8))
c
c convert back to amp and phase and write out the results
c
      do 15 i=1,9
      cload1(i) = phasor(cload1(i))
 15   continue
      if(ifrst.eq.0) then
	 ifrst = 1
	 write(luo,213) modo
 213     format(a1)
	 if(modo.eq.'l') write(luo,215) rlam
 215     format(f8.3)
      endif
      if(type.eq.'o') write(luo,217) icte,cload1(1)
      if(type.eq.'g') write(luo,217) icte,cload1(1)
      if(type.eq.'z') write(luo,217) icte,cload1(4)
      if(type.eq.'d') write(luo,217) icte,cload1(3)
      if(type.eq.'t') write(luo,217) icte,cload1(6)
      if(type.eq.'l') write(luo,217) icte,cload1(8)
      if(type.eq.'s') write(luo,217) icte,cload1(9)
      if(type.eq.'v') write(luo,217) icte,cload1(7)
 217  format(6i2,f9.4,f9.2)
      go to 3
 33   icte(1) = -1
      do 35 i=2,6
 35   icte(i) =  0
      write(luo,217) icte,cz
      stop
      end
      subroutine argand(comp,n)
      complex comp
      dimension comp(n)
      do 3 i=1,n
      p = aimag(comp(i))/57.2958
      a = real(comp(i))
      comp(i) = cmplx(a*cos(p),a*sin(p))
 3    continue
      return
      end

      subroutine fndgde(ftlon,rilon,slat,rnlat,il,ih,jl,jh)
c  returns the cell indices for the corners of a grid
c   ftlon,rilon are the left and right longitudes wanted,
c   slat and rnlat the south and north limits
c  returns the cell indices that cover these, allowing for
c  the case when the limits given are outside the model; will not
c  give the full limits of indices when the longitudes cross the
c  edge of the model.
c
      common/modlim/tlat,blat,wlong,elong,latc,longc
c  put longitudes into model range
      dlongl = amod(ftlon-wlong,360.)
      if(dlongl.lt.0) dlongl = dlongl + 360
      dlongr = amod(rilon-wlong,360.)
      if(dlongr.lt.0) dlongr = dlongr + 360
c allow for limits completely outside the model
      if(slat.gt.tlat.or.rnlat.lt.blat.or.
     1   dlongl.gt.elong-wlong.or.dlongl.gt.elong-wlong) then
        il=0
	ih=0
	jl=0
	jh=0
      endif
      x = (longc*dlongl)/(elong-wlong)
      y = (latc*(tlat-rnlat))/(tlat-blat)
      il= int(x) + 1
      jl= int(y)
      if(rnlat.gt.tlat) jl = 1
      x = (longc*dlongr)/(elong-wlong)
      y = (latc*(tlat-slat))/(tlat-blat)
      ih= int(x) + 1
      jh= int(y)
      if(slat.lt.blat) jh = latc
c if NS edge of model is in grid, ih will be le il (though both are > 0)
      return
      end

      program loadcomb
c
c  combines load files (eg global and local), also with body tides
c
c  reads from standard input at least one load file (two if they
c  are to be combined).
c
c  If there are two files, the values are added, after scaling the
c  values in the second load file by an amplitude and phase (if these
c  are given on the command line). The summed values are written out,
c  with the tilts and strains being (optionally) adjusted to a new direction,
c  if the rotation to this is given on the command line. A single file may
c  be scaled and rotated; added to the body tide; or used to produce the
c  body tide.
c
      character*80 stnam,hedlin
      character*50 mdnam,dumm,dumm2
      character*4 dsym
      character*1 body,dumc
      complex cload1,cload2,scale
      dimension cload1(9),cload2(9),btlt(2),bstr(3),bdis(3)
      common /modpar/mdfile,dsym,icte(6),mdnam
c the following pair of functions convert between complex stored as
c amp and phase and complex stored as real and imaginary
      data luo/6/,lui/5/
      data scale/(1.,0.)/rotdir/0./
      data dumm2/'Body Tide computed for spherical Earth            '/
      data cload1/9*(0.,0.)/
      if(iargc().lt.1.or.iargc().gt.4) then
	 write(luo,100)
 100  format('Usage: loadcomb c [rotation] [scale(amp) scale(phase)] ',/,
     1       '        (reads two load files from std input)',/,
     2  '  or:  loadcomb b [rotation]',/,
     3  '        (reads load file to get location and harmonic, outputs
     4 body tide only)',/,
     5  '  or:  loadcomb t [rotation] [scale (amp) scale (ph)] ',/,
     4  '        (adds body tide to load read in)',/,
     5  '  or:  loadcomb r [rotation] [scale (amp) scale (ph)] ',/,
     6  '        (scales and rotates single load tide read in)')
	 stop
      endif
      call getarg(1,body)
      if(body.ne.'b'.and.body.ne.'t'.and.body.ne.'r'.
     1 and.body.ne.'c'.or.(body.eq.'b'.and.iargc().gt.2)) then
	 write(luo,100)
         stop
      endif
      if(body.eq.'b'.and.iargc().eq.2) then
         call getarg(2,dumm)
         read(dumm,102) rotdir
 102     format(f10.0)
      endif
      if(body.eq.'c'.or.body.eq.'r'.or.body.eq.'t') then
         if(iargc().eq.2) then
            call getarg(2,dumm)
            read(dumm,102) rotdir
         endif
         if(iargc().eq.3) then
            call getarg(2,dumm)
            read(dumm,102) amp
            call getarg(3,dumm)
            read(dumm,102) phase
	    scale = cmplx(amp,phase)
	    call argand(scale,1)
         endif
         if(iargc().eq.4) then
            call getarg(4,dumm)
            read(dumm,102) rotdir
         endif
      endif
c
c done with reading command line
c
      if(body.eq.'b'.or.body.eq.'t') then
c  read in needed information about place from a load file, to compute
c  body tides
         read(lui,201) dumc,stnam, rlat, rlam, ht
 201     format(a1,2x,a40,3x,f10.4,f10.4,f10.0)
         read(lui,203) dumc,dsym,(icte(j),j=1,6),mdnam
 203     format(a1,1x,a4,5x,6i2,5x,a50)
c  compute the body tides, with sign adjusted to make the potential positive
	 call sph(rlat,rlam,ht)
         call cteput(icte,amp,n,m)
	 amp=abs(amp)
         call etharm(amp,n,m,pot,grav,bdis,btlt,bstr)
	 ips = sign(1.0,pot)
	 cload1(1) = ips*cmplx(grav,0.)
c  displacements rearranged to EW NS Z
	 cload1(2) = ips*cmplx(bdis(2),0.)
	 cload1(3) = ips*cmplx(0.,bdis(3))
	 cload1(4) = ips*cmplx(bdis(1),0.)
c  tilts rearranged to EW NS
	 cload1(5) = ips*cmplx(0.,btlt(2))
	 cload1(6) = ips*cmplx(btlt(1),0.)
c  strains rearranged to EW NS EN (shear, which needs a change of sign)
	 cload1(7) = ips*cmplx(bstr(2),0.)
	 cload1(8) = ips*cmplx(bstr(1),0.)
	 cload1(9) = -ips*cmplx(0.,bstr(3))
         write(luo,201) 'S',stnam, rlat, rlam, ht
         if(rotdir.ne.0.0) write(luo,211) rotdir
 211     format('R   vector and tensor quantities in frame rotated by',
	1 f8.2)
         write(luo,203) dumc,dsym,(icte(j),j=1,6),dumm2
	 if(body.eq.'b') then
            write(luo,212)
 212        format('L l          Phases are local, lags negative'/'X')
c body tides only: rotate if need be, write out, and stop
            if(rotdir.ne.0) call rotlod(cload1,rotdir)
	    call phasor(cload1,9)
            write(luo,225) cload1(1)
            write(luo,227) (cload1(i),i=2,4)
            write(luo,229) (cload1(i),i=5,6)
            write(luo,231) (cload1(i),i=7,9)
 225        format('g',9x,2f10.4)
 227        format('d',9x,6f10.4)
 229        format('t',9x,4f10.4)
 231        format('s',9x,6f10.4)
	    stop
         endif
	 if(body.eq.'t') then
            write(luo,203) dumc,dsym,(icte(j),j=1,6),mdnam
c  skip to reading loads into array cload2, since this is the one
c  that is scaled
	    go to  3
         endif
      endif
      if(body.eq.'r') then
c  only reading in one load; read a few lines, and then
c  skip to reading loads into array cload2, since this is the one
c  that is scaled
         read(lui,201) dumc,stnam, rlat, rlam, ht
         write(luo,201) 'S',stnam, rlat, rlam, ht
         read(lui,203) dumc,dsym,(icte(j),j=1,6),mdnam
         write(luo,203) dumc,dsym,(icte(j),j=1,6),mdnam
         if(rotdir.ne.0.0) write(luo,211) rotdir
	 go to 3
      endif
c
c in this case we are combining two load files; read and write the
c header lines for the first one
c
      read(lui,201) dumc,stnam, rlat, rlam, ht
      write(luo,201) dumc,stnam, rlat, rlam, ht
      if(rotdir.ne.0.0) write(luo,211) rotdir
      read(lui,203) dumc,dsym,(icte(j),j=1,6),mdnam
      write(luo,203) dumc,dsym,(icte(j),j=1,6),mdnam
 1    read(lui,200) hedlin
 200  format(a)
      if(hedlin(1:1).ne.'X') write(luo,200) hedlin
      if(hedlin(1:1).ne.'X') go to 1
c      gravity
      read(lui,205) cload1(1)
 205  format(10x,2f10.4)
c      displacement
      read(lui,207) (cload1(i),i=2,4)
 207  format(10x,6f10.4)
c      tilt
      read(lui,209) (cload1(i),i=5,6)
 209  format(10x,4f10.4)
c      strain
      read(lui,207) (cload1(i),i=7,9)
      call argand(cload1,9)
c
c read second load file (the names etc will be from the first one, so we
c have to read and ignore the first line) and add them
c
      read(lui,200) dumm
 3    if(body.eq.'r'.and.scale.ne.(1.,0.)) write(luo,213) amp,phase
 213     format('R   scaling of',g13.5,' (amp) and ',f9.2,' (phase)',
     1      ' applied')
      if(body.eq.'t'.and.scale.ne.(1.,0.)) write(luo,215) amp,phase
 215  format('R   scaling of',g13.5,' (amp) and ',f9.2,' (phase)',
     1      ' applied to load')
      if(body.eq.'c'.and.scale.ne.(1.,0.)) write(luo,217) amp,phase
 217  format('R   scaling of',g13.5,' (amp) and ',f9.2,' (phase)',
     1      ' applied to second load')
 5    read(lui,200) hedlin
      write(luo,200) hedlin
      if(hedlin(1:1).ne.'X') go to 5
      read(lui,205) cload2(1)
      read(lui,207) (cload2(i),i=2,4)
      read(lui,209) (cload2(i),i=5,6)
      read(lui,207) (cload2(i),i=7,9)
      call argand(cload2,9)
      do 7 i=1,9
      cload1(i) = cload1(i) + scale*cload2(i)
 7    continue
c
c adjust to a new direction, rotated rotdir deg (clockwise in the command line,
c converted to counterclockwise below to match the usual formulae) from the
C EW-NS one that the loads are orignally in.
c
      if(rotdir.ne.0) call rotlod(cload1,rotdir)
c
c convert back to amp and phase and write out the results
c
      call phasor(cload1,9)
      write(luo,225) cload1(1)
      write(luo,227) (cload1(i),i=2,4)
      write(luo,229) (cload1(i),i=5,6)
      write(luo,231) (cload1(i),i=7,9)
      stop
      end
c
c
      subroutine rotlod(cl,az)
c rotates loads by amount az
      complex cl,cl2
      dimension cl(9),cl2(9)
      caz = cos(-az/57.2958)
      saz = sin(-az/57.2958)
      cl2(1) = cl(1)
      cl2(4) = cl(4)
c           horizontal displacements (2 EW 3 NS 4 vert)
      cl2(2) = caz*cl(2) + saz*cl(3)
      cl2(3) = -saz*cl(2) + caz*cl(3)
c           tilts (5 EW 6 NS)
      cl2(5) = caz*cl(5) + saz*cl(6)
      cl2(6) = -saz*cl(5) + caz*cl(6)
c           strains (originally, 7 is EW 8 NS 9 shear (EN) )
      cl2(7) = caz*caz*cl(7) + saz*saz*cl(8) + 2*caz*saz*cl(9)
      cl2(8) = caz*caz*cl(8) + saz*saz*cl(7) - 2*caz*saz*cl(9)
      cl2(9) = cl(9)*(caz*caz-saz*saz) - caz*saz*(cl(7)-cl(8))
      do 13 i=1,9
 13   cl(i) = cl2(i)
      return
      end
c
c
      subroutine argand(comp,n)
      complex comp
      dimension comp(n)
      do 3 i=1,n
      p = aimag(comp(i))/57.2958
      a = real(comp(i))
      comp(i) = cmplx(a*cos(p),a*sin(p))
 3    continue
      return
      end
c
c
      subroutine phasor(comp,n)
      complex comp
      dimension comp(n)
      do 3 i=1,n
      p = 57.2958*atan2(aimag(comp(i)),real(comp(i)))
      a = cabs(comp(i))
      comp(i) = cmplx(a,p)
 3    continue
      return
      end
